## plplot 5.10.0+dfsg2

=== CMakeLists.txt ===
# Top-level CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2012 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Recommended way to do user overrides of C-related variables, is given at
# http://public.kitware.com/pipermail/cmake/2006-July/010334.html.
# See also, CMakeCInformation.cmake.  There are also C++, and Fortran-specific
# overrides that can be done.  However, I prefer putting overrides in just
# one file so I use the overall variable CMAKE_USER_MAKE_RULES_OVERRIDE
# instead.
set(
  CMAKE_USER_MAKE_RULES_OVERRIDE
  ${CMAKE_SOURCE_DIR}/cmake/UserOverride.cmake
  )

cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)

# cmake-2.8.12.1 (2.8.12 screwed up the implementation) introduced a
# corrected implementation of keyword signatures for
# target_link_libraries which are preferred now over the traditional
# plain signatures.  There are a lot of implications concerning these
# preferred keyword signatures which I don't understand at the moment,
# but it is clear some modifications to our build system will be
# required to start using keyword signatures appropriately.  But it is
# also clear we can do nothing about this until we can guarantee that
# all our users are running 2.8.12.1 or higher.  Therefore, until we
# bump the actual minimum version to 2.8.12.1 in the above
# cmake_minimum_required call and deal with all the errors in our
# CMake code that will generate, quiet the warnings about this issue
# by explicitly setting policies CMP0022 and CMP0023 (if they exist
# for whatever CMake version the user is running) to OLD.
if(POLICY CMP0022)
  message(STATUS "Explicitly setting policy CMP0022 to OLD")
  cmake_policy(SET CMP0022 OLD)
endif(POLICY CMP0022)
if(POLICY CMP0023)
  message(STATUS "Explicitly setting policy CMP0023 to OLD")
  cmake_policy(SET CMP0023 OLD)
endif(POLICY CMP0023)

# It is a fatal error if no working C compiler is available to build
# the PLplot core C library and core C examples.  All other compilers
# required by our bindings are optional in that if no working compiler
# of the kind needed is available, the associated bindings and
# examples are disabled.
project(plplot C)

message(STATUS "CMake version = ${CMAKE_VERSION}")
message(STATUS "CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")

# Set unambiguous names for these variables as a reminder.
set(WIN32_AND_NOT_CYGWIN ${WIN32})
if(WIN32 OR CYGWIN)
  set(WIN32_OR_CYGWIN ON)
else(WIN32 OR CYGWIN)
  set(WIN32_OR_CYGWIN OFF)
endif(WIN32 OR CYGWIN)

#foreach(policy RANGE 0 9)
#  cmake_policy(GET CMP000${policy} policy_result)
#  message(STATUS "Policy CMP000${policy} is ${policy_result}")
#endforeach(policy RANGE 0 9)

set(PACKAGE plplot)

# Locations where PLplot cmake build system first looks for cmake modules.
set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake/modules
  ${PROJECT_SOURCE_DIR}/cmake/modules/language_support/cmake
  ${PROJECT_SOURCE_DIR}/cmake/modules/language_support/cmake-2.8
  )

# We need the path to the MinGW/Borland compiler in order to find
# the import libraries for system libraries.
if(MINGW)
  get_filename_component(MINGWBINPATH ${CMAKE_C_COMPILER} PATH)
  set(MINGWLIBPATH ${MINGWBINPATH}/../lib
    CACHE FILEPATH
    DOCSTRING "Path to MinGW import libraries")
endif(MINGW)
if(BORLAND)
  get_filename_component(BORLANDBINPATH ${CMAKE_C_COMPILER} PATH)
  set(BORLANDLIBPATH ${BORLANDBINPATH}/../Lib/PSDK
    CACHE FILEPATH
    DOCSTRING "Path to Borland import libraries")
endif(BORLAND)

# Version data that need modification for each release.
include(plplot_version)
# parameters to control overall cmake behaviour.

# Configure PLplot component variables....

include(plplot)

# Use configured variables to process configurable top-level files.

# This CMake-configured template file is processed further by sed for
# abi-compliance-checker.
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/abi-compliance-checker.xml.template.in
  ${CMAKE_CURRENT_BINARY_DIR}/abi-compliance-checker.xml.template
  @ONLY
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/plplot_config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/plplot_config.h
  )
# Allow access to the generated plplot_config.h for this build.
add_definitions("-DHAVE_CONFIG_H")
# Install top-level files

# Enable testing framework for examples
if(BUILD_TEST)
  include(CTest)
endif(BUILD_TEST)

# Disable warnings about deprecated functions (Visual C++ 2005)
if(MSVC_VERSION GREATER 1399)
  add_definitions("/D_CRT_SECURE_NO_DEPRECATE")
endif(MSVC_VERSION GREATER 1399)

# Borland Compiler must compile in ANSII mode
if(BORLAND)
  add_definitions(-A)
endif(BORLAND)

set(top_level_DOCFILES
  ABOUT
  AUTHORS
  COPYING.LIB
  ChangeLog.release
  Copyright
  FAQ
  NEWS
  PROBLEMS
  README
  README.release
  README.testing
  )
install(FILES ${top_level_DOCFILES} DESTINATION ${DOC_DIR})

if(BUILD_SHARED_LIBS AND WIN32_OR_CYGWIN)
  # For platforms (currently WIN32 or Cygwin, although the Cygwin version
  # of CMake may support this in future since -rpath apparently does work
  # on that platform) where CMake does not use -rpath, use a workaround
  # where all dll's are collected in the dll subdirectory of the build tree.
  set(USE_DLL_SUBDIRECTORY ON)
else(BUILD_SHARED_LIBS AND WIN32_OR_CYGWIN)
  set(USE_DLL_SUBDIRECTORY OFF)
endif(BUILD_SHARED_LIBS AND WIN32_OR_CYGWIN)

# in windows all created dlls are gathered in the dll directory
# if you add this directory to your PATH all shared libraries are available
if(USE_DLL_SUBDIRECTORY)
  set(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/dll)
endif(USE_DLL_SUBDIRECTORY)

# Process other directories including using configured variables to
# process configurable files in those directories.
# N.B. Order is important here at the cmake stage because targets must
# be processed by cmake in a specific order e.g., due to get_target_property
# invocations.  Note, this order has nothing to do with the order which make
# processes these subdirectories at build time.  That build-time order
# is determined by the dependencies between targets and also by file
# dependencies that are established by the cmake configuration files.

add_subdirectory(fonts)
add_subdirectory(lib)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(bindings)
add_subdirectory(drivers)
add_subdirectory(utils)
add_subdirectory(examples)
add_subdirectory(plplot_test)
add_subdirectory(scripts)
add_subdirectory(doc)
add_subdirectory(www)
add_subdirectory(pkgcfg)
summary()

if(PREBUILD_DIST)
  # Pre-build everything required for a distribution tarball and copy it to
  # the source tree (if build tree is different from source tree).

  # List of targets that must be (pre-)built.
  set(DIST_TARGETS)

  if(ENABLE_octave)
    list(APPEND DIST_TARGETS make_documentation)
  endif(ENABLE_octave)

  if(BUILD_PRINT)
    list(APPEND DIST_TARGETS print)
  endif(BUILD_PRINT)

  if(BUILD_INFO)
    list(APPEND DIST_TARGETS info)
  endif(BUILD_INFO)

  if(BUILD_MAN)
    list(APPEND DIST_TARGETS man)
  endif(BUILD_MAN)

  if(BUILD_HTML)
    list(APPEND DIST_TARGETS html)
  endif(BUILD_HTML)

  if(BUILD_DOX_DOC)
    list(APPEND DIST_TARGETS build_doxygen)
  endif(BUILD_DOX_DOC)

  if(CMAKE_BINARY_DIR STREQUAL "${CMAKE_SOURCE_DIR}")
    add_custom_target(prebuild_dist)
  else(CMAKE_BINARY_DIR STREQUAL "${CMAKE_SOURCE_DIR}")
    # copy prebuilds back to source tree.
    # N.B. copy_directory quietly creates an empty directory with no
    # error condition if the source directory does not exist.
    add_custom_target(
      prebuild_dist
      COMMAND ${CMAKE_COMMAND} -E remove_directory
      ${CMAKE_SOURCE_DIR}/bindings/octave/plplot_octave_txt
      COMMAND ${CMAKE_COMMAND} -E copy_directory
      ${CMAKE_BINARY_DIR}/bindings/octave/plplot_octave_txt
      ${CMAKE_SOURCE_DIR}/bindings/octave/plplot_octave_txt
      COMMAND ${CMAKE_COMMAND} -E remove_directory
      ${CMAKE_SOURCE_DIR}/doc/doxygen
      COMMAND ${CMAKE_COMMAND} -E copy_directory
      ${CMAKE_BINARY_DIR}/doc/doxygen
      ${CMAKE_SOURCE_DIR}/doc/doxygen
      COMMAND cp
      `cat static_built_files ${INFO_MANIFEST} ${MAN_MANIFEST} ${HTML_MANIFEST}`
      ${CMAKE_SOURCE_DIR}/doc/docbook/src
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/doc/docbook/src
      )
  endif(CMAKE_BINARY_DIR STREQUAL "${CMAKE_SOURCE_DIR}")
  add_dependencies(prebuild_dist ${DIST_TARGETS})
endif(PREBUILD_DIST)

#
# Packing stuff
#
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Scientific Plotting Library PLplot")
set(CPACK_PACKAGE_VENDOR "PLplot development team")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/README)
set(CPACK_SET_DESTDIR ON)
if(WIN32_AND_NOT_CYGWIN)
  set(CPACK_GENERATOR ZIP)
else(WIN32_AND_NOT_CYGWIN)
  set(CPACK_GENERATOR TGZ)
endif(WIN32_AND_NOT_CYGWIN)
set(
  CPACK_SOURCE_PACKAGE_FILE_NAME
  "plplot-${PLPLOT_VERSION}"
  CACHE INTERNAL "tarball basename"
  )
set(CPACK_SOURCE_GENERATOR TGZ)
# The following components are regex's to match anywhere (unless anchored)
# in absolute path + filename to find files or directories to be excluded
# from source tarball.
set(CPACK_SOURCE_IGNORE_FILES
  "\\\\#*\\\\#$"
  "~$"
  "\\\\.cvsignore$"
  "^${PROJECT_SOURCE_DIR}.*/\\\\.svn/"
  "^${PROJECT_SOURCE_DIR}/old/"
  "^${PROJECT_SOURCE_DIR}/sys/mac"
  "^${PROJECT_SOURCE_DIR}/sys/os2"
  "^${PROJECT_SOURCE_DIR}/sys/unix"
  "^${PROJECT_SOURCE_DIR}/sys/dos/msc"
  "^${PROJECT_SOURCE_DIR}/sys/dos/bcc"
  "^${PROJECT_SOURCE_DIR}/sys/dos/emx"
  "^${PROJECT_SOURCE_DIR}/sys/win-tk"
  "^${PROJECT_SOURCE_DIR}/sys/win32"
  "^${PROJECT_SOURCE_DIR}/debian"
  )
#message("CPACK_SOURCE_IGNORE_FILES = ${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)

# Path to native build for executables required in the build process.
# This is only required for cross compiling
if(CMAKE_CROSSCOMPILING)
  set(CMAKE_NATIVE_BINARY_DIR NATIVEDIR-NOTFOUND CACHE FILEPATH "Point to the native build directory")
endif(CMAKE_CROSSCOMPILING)

=== examples/CMakeLists.txt ===
# examples/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2013 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. This file is used for both the core build (which installs the examples
# and optionally [depending on BUILD_TEST} builds them) and the installed
# examples build.  The core build has BUILD_TEST OFF or ON at user option
# and CORE_BUILD always ON.  The installed examples build always has
# BUILD_TEST ON and CORE_BUILD OFF.

if(CORE_BUILD)
  # Configure Makefile.examples with some specific variables for the
  # traditional Makefile + pkg-config installed examples build.

  # cxx and tk subdirectories are special cases.
  if(PLD_ps)
    if(NOT ENABLE_ada)
      set(PSC_ADA_COMMENT "#")
    endif(NOT ENABLE_ada)

    if(NOT ENABLE_d)
      set(PSC_D_COMMENT "#")
    endif(NOT ENABLE_d)

    if(NOT ENABLE_f95)
      set(PSC_F95_COMMENT "#")
    endif(NOT ENABLE_f95)

    if(NOT ENABLE_java)
      set(PSC_JAVA_COMMENT "#")
    endif(NOT ENABLE_java)

    if(NOT ENABLE_ocaml)
      set(PSC_OCAML_COMMENT "#")
    endif(NOT ENABLE_ocaml)

    if(NOT ENABLE_octave)
      set(PSC_OCTAVE_COMMENT "#")
    endif(NOT ENABLE_octave)

    if(NOT ENABLE_pdl)
      set(PSC_PERL_COMMENT "#")
    endif(NOT ENABLE_pdl)

    if(NOT ENABLE_python)
      set(PSC_PYTHON_COMMENT "#")
    endif(NOT ENABLE_python)

    if(NOT ENABLE_tcl)
      set(PSC_TCL_COMMENT "#")
    endif(NOT ENABLE_tcl)

    if(NOT ENABLE_lua)
      set(PSC_LUA_COMMENT "#")
    endif(NOT ENABLE_lua)

  else(PLD_ps)
    set(PSC_ADA_COMMENT "#")
    set(PSC_C_COMMENT "#")
    set(PSC_D_COMMENT "#")
    set(PSC_F95_COMMENT "#")
    set(PSC_JAVA_COMMENT "#")
    set(PSC_OCAML_COMMENT "#")
    set(PSC_OCTAVE_COMMENT "#")
    set(PSC_PERL_COMMENT "#")
    set(PSC_PYTHON_COMMENT "#")
    set(PSC_TCL_COMMENT "#")
  endif(PLD_ps)

  if(NOT(ENABLE_cxx AND (PLD_ps OR ENABLE_qt)))
    set(CXX_COMMENT "#")
  endif(NOT(ENABLE_cxx AND (PLD_ps OR ENABLE_qt)))

  if(NOT ENABLE_tkX)
    set(TK_COMMENT "#")
  endif(NOT ENABLE_tkX)

  if(NOT PLD_pdfcairo)
    set(PDFCAIRO_COMMENT "#")
  endif(NOT PLD_pdfcairo)

  if(NOT PLD_pngcairo)
    set(PNGCAIRO_COMMENT "#")
  endif(NOT PLD_pngcairo)

  if(NOT PLD_pscairo)
    set(PSCAIRO_COMMENT "#")
  endif(NOT PLD_pscairo)

  if(NOT PLD_epscairo)
    set(EPSCAIRO_COMMENT "#")
  endif(NOT PLD_epscairo)

  if(NOT PLD_svgcairo)
    set(SVGCAIRO_COMMENT "#")
  endif(NOT PLD_svgcairo)

  if(NOT PLD_gif)
    set(GIF_COMMENT "#")
  endif(NOT PLD_gif)

  if(NOT PLD_jpeg)
    set(JPEG_COMMENT "#")
  endif(NOT PLD_jpeg)

  if(NOT PLD_png)
    set(PNG_COMMENT "#")
  endif(NOT PLD_png)

  if(NOT PLD_psttf)
    set(PSTTFC_COMMENT "#")
  endif(NOT PLD_psttf)

  if(NOT PLD_svg)
    set(SVG_COMMENT "#")
  endif(NOT PLD_svg)

  if(NOT PLD_xfig)
    set(XFIG_COMMENT "#")
  endif(NOT PLD_xfig)

  if(NOT PLD_pstex)
    set(PSTEX_COMMENT "#")
  endif(NOT PLD_pstex)

  if(CMP_EXECUTABLE OR DIFF_EXECUTABLE AND TAIL_EXECUTABLE)
    set(COMPARE_COMMENT)
  else(CMP_EXECUTABLE OR DIFF_EXECUTABLE AND TAIL_EXECUTABLE)
    set(COMPARE_COMMENT "#")
  endif(CMP_EXECUTABLE OR DIFF_EXECUTABLE AND TAIL_EXECUTABLE)

  if(NOT PLD_cgm)
    set(CGM_COMMENT "#")
  endif(NOT PLD_cgm)

  if(NOT PLD_bmpqt)
    set(BMPQT_COMMENT "#")
  endif(NOT PLD_bmpqt)

  if(NOT PLD_jpgqt)
    set(JPGQT_COMMENT "#")
  endif(NOT PLD_jpgqt)

  if(NOT PLD_pngqt)
    set(PNGQT_COMMENT "#")
  endif(NOT PLD_pngqt)

  if(NOT PLD_ppmqt)
    set(PPMQT_COMMENT "#")
  endif(NOT PLD_ppmqt)

  if(NOT PLD_tiffqt)
    set(TIFFQT_COMMENT "#")
  endif(NOT PLD_tiffqt)

  if(NOT PLD_svgqt)
    set(SVGQT_COMMENT "#")
  endif(NOT PLD_svgqt)

  if(NOT PLD_epsqt)
    set(EPSQT_COMMENT "#")
  endif(NOT PLD_epsqt)

  if(NOT PLD_pdfqt)
    set(PDFQT_COMMENT "#")
  endif(NOT PLD_pdfqt)

  if(FORCE_EXTERNAL_STATIC)
    # This experiment option untested, but it should work as well as
    # FORCE_EXTERNAL_STATIC does for the CMake linking case for the
    # core build in the build tree.  That is, not well at all (drivers
    # limited to those without external dependencies and languages limited
    # to C, C++, D, and Fortran 95) because
    # of severe limitations in static library support on Linux.

    # pkg-config does use --static option for traditional installed examples build.
    set(PC_STATIC_OPTION "--static")
  else(FORCE_EXTERNAL_STATIC)
    # pkg-config does not use --static option for traditional installed examples build.
    set(PC_STATIC_OPTION)
  endif(FORCE_EXTERNAL_STATIC)

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Makefile.examples.in
    ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples
    @ONLY
    )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples 
    DESTINATION ${DATA_DIR}/examples
    RENAME Makefile
    )

  # Sort out RPATH issues for traditional build of installed examples using
  # */Makefiles configured in each * subdirectory from */Makefile.examples.in.
  if(USE_RPATH)
    get_target_property(_LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    if(_LIB_INSTALL_RPATH)
      string(REGEX REPLACE ";" ":" LIB_INSTALL_RPATH "${_LIB_INSTALL_RPATH}")
      set(RPATHCMD "-Wl,-rpath -Wl,${LIB_INSTALL_RPATH}")
      if(PLD_extqt)
	if(ENABLE_DYNDRIVERS)
	  get_target_property(_qt_INSTALL_RPATH qt INSTALL_RPATH)
	  if(_qt_INSTALL_RPATH)
	    string(REGEX REPLACE ";" ":" qt_INSTALL_RPATH "${_qt_INSTALL_RPATH}")
	    set(qt_RPATHCMD "-Wl,-rpath -Wl,${LIB_INSTALL_RPATH}:${qt_INSTALL_RPATH}:${DRV_DIR}")
	  else(_qt_INSTALL_RPATH)
	    set(qt_RPATHCMD)
	  endif(_qt_INSTALL_RPATH)
	else(ENABLE_DYNDRIVERS)
	  set(qt_RPATHCMD ${RPATHCMD})
	endif(ENABLE_DYNDRIVERS)
      endif(PLD_extqt)
      if(ENABLE_tcl)
	get_target_property(_plplottcltk_Main_INSTALL_RPATH plplottcltk_Main${LIB_TAG} INSTALL_RPATH)
	if(_plplottcltk_Main_INSTALL_RPATH)
	  string(REGEX REPLACE ";" ":" plplottcltk_Main_INSTALL_RPATH "${_plplottcltk_Main_INSTALL_RPATH}")
	  set(plplottcltk_Main_RPATHCMD "-Wl,-rpath -Wl,${LIB_INSTALL_RPATH}:${plplottcltk_Main_INSTALL_RPATH}")
	else(_plplottcltk_Main_INSTALL_RPATH)
	  set(plplottcltk_Main_RPATHCMD)
	endif(_plplottcltk_Main_INSTALL_RPATH)
      endif(ENABLE_tcl)
    else(_LIB_INSTALL_RPATH)
      set(RPATHCMD)
      set(qt_RPATHCMD)
      set(plplottcltk_Main_RPATHCMD)
    endif(_LIB_INSTALL_RPATH)
    
  endif(USE_RPATH)

  # Install lena.pgm in installed examples directory so that all implementations
  # of example 20 in the various examples subdirectories can conveniently
  # access this file.
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lena.pgm
    DESTINATION ${DATA_DIR}/examples
    )

endif(CORE_BUILD)

if(CORE_BUILD)
  # These variables (normally not set or needed for a core build) are
  # needed below for the tests of the languages and devices.  They
  # are also needed to configure plplot_configure.cmake whose template
  # file is plplot_configure.cmake_installed_examples.in and which
  # ends up installed in examples/cmake/module.
  set(ENABLE_c ON)
  set(PLD_psc ${PLD_ps})
  set(PLD_psttfc ${PLD_psttf})
  # The psc device handled separately below so don't add it to
  # FILE_DEVICES_LIST.
  if(PLD_psttfc)
    list(APPEND FILE_DEVICES_LIST psttfc:psttf:OFF)
  endif(PLD_psttfc)

  # Start configuration/installation of CMake-based build system for
  # installed examples.
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
    DESTINATION ${DATA_DIR}/examples
    )

  # language_info_LIST contains information about the languages used in
  # the noninteractive tests.  The first field is language (which must be
  # consistent with the list of languages configured by set commands in
  # examples/plplot_configure.cmake_installed_examples.in).  The second
  # field is the subdirectory corresponding to the language.  The third
  # field is the file suffix on plplot-test.sh results for that language.
  # N.B. this list is configured in plplot_configure.cmake below and
  # is therefore available both for the core build of the tests and
  # the installed-examples build of the tests below.

  set(language_info_LIST
    ada:ada:a
    c:c:c
    cxx:c++:cxx
    d:d:d
    f95:f95:f95
    java:java:j
    lua:lua:lua
    ocaml:ocaml:ocaml
    octave:octave:o
    pdl:perl:pdl
    python:python:p
    tcl:tcl:t
    )

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/plplot_configure.cmake_installed_examples.in
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_configure.cmake_installed_examples
    @ONLY
    )

  install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_configure.cmake_installed_examples
    DESTINATION ${DATA_DIR}/examples/cmake/modules
    RENAME plplot_configure.cmake
    )

  # function support for CMake-based build system for installed examples.
  install(FILES
    ${CMAKE_SOURCE_DIR}/cmake/modules/plplot_functions.cmake
    DESTINATION ${DATA_DIR}/examples/cmake/modules
    )

  # pkg-config support for CMake-based build system for installed examples.
  install(FILES
    ${CMAKE_SOURCE_DIR}/cmake/modules/pkg-config.cmake
    DESTINATION ${DATA_DIR}/examples/cmake/modules
    )

  # Install soft-landing support for compiler detection/testing.
  install(FILES
    ${CMAKE_SOURCE_DIR}/cmake/modules/language_support.cmake 
    DESTINATION ${DATA_DIR}/examples/cmake/modules
    )

  # Install qt support file.
  if(ANY_QT_DEVICE)
    install(FILES
    ${CMAKE_SOURCE_DIR}/cmake/modules/ndp_UseQt4.cmake 
    DESTINATION ${DATA_DIR}/examples/cmake/modules
    )
  endif(ANY_QT_DEVICE)

  # Install PLplot-specific language support files needed for CMake-based
  # build of installed examples.
  # N.B. This list of files must be maintained consistently with the file
  # lists in cmake/modules/language_support.cmake.

  set(LANG_SUPPORT_FILES)

  if(ENABLE_ada)
    set(LANG_SUPPORT_FILES ${LANG_SUPPORT_FILES}
      language_support/cmake:CMakeAdaCompiler.cmake.in
      language_support/cmake:CMakeAdaInformation.cmake
      language_support/cmake:CMakeDetermineAdaCompiler.cmake
      language_support/cmake:CMakeTestAdaCompiler.cmake
      )
  endif(ENABLE_ada)

  if(ENABLE_d)
    set(LANG_SUPPORT_FILES ${LANG_SUPPORT_FILES}
      language_support/cmake:CMakeD_Copyright.txt
      language_support/cmake:CMakeDCompiler.cmake.in
      language_support/cmake:CMakeDInformation.cmake
      language_support/cmake:CMakeDetermineDCompiler.cmake
      language_support/cmake:CMakeTestDCompiler.cmake
      language_support/cmake/Platform:Darwin-dmd.cmake
      language_support/cmake/Platform:Linux-dmd.cmake
      language_support/cmake/Platform:Linux-gdc.cmake
      language_support/cmake/Platform:Windows-dmd.cmake
      language_support/cmake/Platform:Windows-gdc.cmake
      language_support/cmake/Platform:Windows-gdc.cmake
      )
  endif(ENABLE_d)

  if(LANG_SUPPORT_FILES)
    foreach(LANG_SUPPORT_info ${LANG_SUPPORT_FILES})
      string(REGEX REPLACE "^(.*):.*$" "\\1" LANG_SUPPORT_DIR ${LANG_SUPPORT_info})
      string(REGEX REPLACE "^.*:(.*)$" "\\1" LANG_SUPPORT_FILE ${LANG_SUPPORT_info})
      install(FILES
	${CMAKE_SOURCE_DIR}/cmake/modules/${LANG_SUPPORT_DIR}/${LANG_SUPPORT_FILE}
	DESTINATION ${DATA_DIR}/examples/cmake/modules/${LANG_SUPPORT_DIR}
	)
    endforeach(LANG_SUPPORT_info ${LANG_SUPPORT_FILES})
  endif(LANG_SUPPORT_FILES)

else(CORE_BUILD)
  project(installed_plplot_examples NONE)
  message(STATUS "CMake version = ${CMAKE_VERSION}")

=== pkgcfg/CMakeLists.txt ===
# pkgcfg/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

install(FILES README DESTINATION ${DOC_DIR} RENAME README.pkg-config)

=== plplot_test/CMakeLists.txt ===
# plplot_test/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2013 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Only set up test environment, configure test files, and install them if
# a shell is available.

if(SH_EXECUTABLE)
  set(SCRIPTS)
  set(TEST_ENVIRONMENT
    "EXAMPLES_DIR=${CMAKE_BINARY_DIR}/examples SRC_EXAMPLES_DIR=${CMAKE_SOURCE_DIR}/examples"
    )

  set(TEST_DEVICE psc CACHE STRING "device used for ctest")
  # There is no PLD_psc or PLD_psttfc and the PLD_ps and PLD_psttf
  # variables must be used instead.  All other PLD_* names correspond
  # to exact device names.  So adjust for this complicated naming
  # scheme in a general way in case some other TEST_DEVICE is chosen
  # in the future.
  if(TEST_DEVICE STREQUAL "psc")
    set(PLD_TEST_DEVICE ${PLD_ps})
  elseif(TEST_DEVICE STREQUAL "psttfc")
    set(PLD_TEST_DEVICE ${PLD_psttf})
  else(TEST_DEVICE STREQUAL "psc")
    set(PLD_TEST_DEVICE ${PLD_${TEST_DEVICE}})
  endif(TEST_DEVICE STREQUAL "psc")

  set(TEST_SCRIPT "./plplot-test.sh --verbose")
  set(TEST_SCRIPT_DEVICE "${TEST_SCRIPT} --device=${TEST_DEVICE}")

  set(JAVA_TEST_ENVIRONMENT "${TEST_ENVIRONMENT} PLPLOT_JAVA_WRAP_DIR=${CMAKE_BINARY_DIR}/bindings/java/ PLPLOT_CLASSPATH=${CMAKE_BINARY_DIR}/examples/java/plplot.jar")

  #Build-tree configuration
  set(CONFIGURED_EXAMPLES_DIR EXAMPLES_DIR)
  configure_file(
    plplot-test.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/plplot-test.sh
    @ONLY
    )

  #Install-tree configuration
  set(CONFIGURED_EXAMPLES_DIR SRC_EXAMPLES_DIR)
  configure_file(
    plplot-test.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/plplot-test.sh_install
    @ONLY
    )

  # Set up optional tests in the configured plplot-test-interactive.sh file.

  set(pkgIndex_LOCATION ${DATA_DIR})
  set(SHELL_TEST_PLTCL_STANDARD_EXAMPLES 1)
  set(SHELL_TEST_PLSERVER_STANDARD_EXAMPLES 1)
  # FIXME.  Currently plserver_runAllDemos needs work so drop it for now.
  set(SHELL_TEST_PLSERVER_RUNALLDEMOS 0)

  # All Tcl/Tk tests that use the "package require" approach only
  # work with shared libraries.
  if(BUILD_SHARED_LIBS)
    set(SHELL_TEST_TCLSH_STANDARD_EXAMPLES 1)
    # FIXME.  Currently wish_standard_examples segfaults on exit.  So
    # drop it for now.
    set(SHELL_TEST_WISH_STANDARD_EXAMPLES 0)
    # FIXME.  Currently the wish_runAllDemos needs work and also has
    # an intermittent bug (x?? not recognized as a command).
    set(SHELL_TEST_WISH_RUNALLDEMOS 0)
  else(BUILD_SHARED_LIBS)
    set(SHELL_TEST_TCLSH_STANDARD_EXAMPLES 0)
    set(SHELL_TEST_WISH_STANDARD_EXAMPLES 0)
    set(SHELL_TEST_WISH_RUNALLDEMOS 0)
  endif(BUILD_SHARED_LIBS)

  configure_file(
    plplot-test-interactive.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/plplot-test-interactive.sh
    @ONLY
    )

  configure_file(
    test_c.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/test_c.sh
    @ONLY
    )
  list(APPEND SCRIPTS test_c.sh)

  configure_file(
    test_c_interactive.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/test_c_interactive.sh
    @ONLY
    )
  list(APPEND SCRIPTS test_c_interactive.sh)

  set(test_output_files_LIST)
  set(examples_compare_DEPENDS)

  if(PLD_TEST_DEVICE)
    add_test(examples_c
      ${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=c"
      )
    list(APPEND examples_compare_DEPENDS examples_c)
    list_example_files(. ${TEST_DEVICE} c output_list)
    list(APPEND test_output_files_LIST ${output_list})
  endif(PLD_TEST_DEVICE)

  if(ENABLE_cxx)
    configure_file(
      test_cxx.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_cxx.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_cxx.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_cxx
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=cxx"
	)
      list(APPEND examples_compare_DEPENDS examples_cxx)
      list_example_files(. ${TEST_DEVICE} cxx output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_cxx)

  if(ENABLE_f95)
    configure_file(
      test_f95.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_f95.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_f95.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_f95
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=f95"
	)
      list(APPEND examples_compare_DEPENDS examples_f95)
      list_example_files(. ${TEST_DEVICE} f95 output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_f95)

  if(ENABLE_java)
    configure_file(
      test_java.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_java.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_java.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_java
	${SH_EXECUTABLE} -c "${JAVA_TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=java"
	)
      list(APPEND examples_compare_DEPENDS examples_java)
      list_example_files(. ${TEST_DEVICE} j output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_java)

  if(ENABLE_octave)

    configure_file(
      test_octave_interactive.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_octave_interactive.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_octave_interactive.sh)

    configure_file(
      test_octave.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_octave.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_octave.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_octave
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=octave"
	)
      list(APPEND examples_compare_DEPENDS examples_octave)
      list_example_files(. ${TEST_DEVICE} o output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_octave)

  if(ENABLE_python)
    configure_file(
      test_python.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_python.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_python.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_python
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=python"
	)
      list(APPEND examples_compare_DEPENDS examples_python)
      list_example_files(. ${TEST_DEVICE} p output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_python)

  if(ENABLE_tcl)
    get_target_property(pltcl_LOC pltcl LOCATION)
    string(REGEX REPLACE "/pltcl.*$" "" PLTCL_DIR ${pltcl_LOC})
    # Experience with MSYS bash shows that variables used to set a
    # PATH component must transform the drive-letter form to the
    # leading-slash Unix form of the PATH component.  The case of the
    # drive letter doesn't matter.  For example converting
    # z:/whatever/path ==> /z/whatever/path or /Z/whatever/path works
    # fine for MSYS bash.
    string(REGEX REPLACE "^(.):/" "/\\1/" PLTCL_DIR ${PLTCL_DIR})


    configure_file(test_tcl.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_tcl.sh
      @ONLY
      )
    if(PLD_TEST_DEVICE)
      add_test(examples_tcl
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=tcl"
	)
      list(APPEND examples_compare_DEPENDS examples_tcl)
      list_example_files(. ${TEST_DEVICE} t output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
    set(PLTCL_DIR ${BIN_DIR})
    # Transform drive-letter form to leading-slash form, see comment above.
    string(REGEX REPLACE "^(.):" "/\\1/" PLTCL_DIR ${PLTCL_DIR})

    configure_file(test_tcl.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_tcl.sh_install
      @ONLY
      )
  endif(ENABLE_tcl)

  if(ENABLE_pdl)
    configure_file(
      test_pdl.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_pdl.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_pdl.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_pdl
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=pdl"
	)
      list(APPEND examples_compare_DEPENDS examples_pdl)
      list_example_files(. ${TEST_DEVICE} pdl output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_pdl)

  if(ENABLE_ada)
    configure_file(
      test_ada.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_ada.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_ada.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_ada
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=ada"
	)
      list(APPEND examples_compare_DEPENDS examples_ada)
      list_example_files(. ${TEST_DEVICE} a output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_ada)

  if(ENABLE_ocaml)
    configure_file(
      test_ocaml.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_ocaml.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_ocaml.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_ocaml
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=ocaml"
	)
      list(APPEND examples_compare_DEPENDS examples_ocaml)
      list_example_files(. ${TEST_DEVICE} ocaml output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_ocaml)

  if(ENABLE_lua)
    configure_file(
      test_lua.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_lua.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_lua.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_lua
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=lua"
	)
      list(APPEND examples_compare_DEPENDS examples_lua)
      list_example_files(. ${TEST_DEVICE} lua output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_lua)

  if(ENABLE_d)
    configure_file(
      test_d.sh.in
      ${CMAKE_CURRENT_BINARY_DIR}/test_d.sh
      @ONLY
      )
    list(APPEND SCRIPTS test_d.sh)
    if(PLD_TEST_DEVICE)
      add_test(examples_d
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT_DEVICE} --front-end=d"
	)
      list(APPEND examples_compare_DEPENDS examples_d)
      list_example_files(. ${TEST_DEVICE} d output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(PLD_TEST_DEVICE)
  endif(ENABLE_d)

  # Run C examples with different drivers
  if(PLD_ps)
    if (NOT TEST_DEVICE STREQUAL "psc")
      add_test(examples_psc
	${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT} --front-end=c --device=psc"
	)
      list_example_files(. psc c output_list)
      list(APPEND test_output_files_LIST ${output_list})
    endif(NOT TEST_DEVICE STREQUAL "psc")
  endif(PLD_ps)

  if(PLD_psttf)
    add_test(examples_psttfc
      ${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT} --front-end=c --device=psttfc"
      )
    list_example_files(. psttfc c output_list)
    list(APPEND test_output_files_LIST ${output_list})
  endif(PLD_psttf)

  if(PLD_pstex)
    add_test(examples_pstex
      ${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT} --front-end=c --device=pstex"
      )
    list_example_files(. pstex c output_list)
    list(APPEND test_output_files_LIST ${output_list})
  endif(PLD_pstex)

  if(PLD_png)
    add_test(examples_png
      ${SH_EXECUTABLE} -c "${TEST_ENVIRONMENT} ${TEST_SCRIPT} --front-end=c --device=png"
      )
    list_example_files(. png c output_list)

=== src/CMakeLists.txt ===
# src/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

set(plplot${LIB_TAG}_LIB_SRCS
  pdfutils.c
  plaffine.c
  plarc.c
  plargs.c
  plbox.c
  plcont.c
  plcore.c
  plctrl.c
  plcvt.c
  pldtik.c
  plf2ops.c
  plfill.c
  plfreetype.c
  plgradient.c
  plhist.c
  plimage.c
  plline.c
  plmap.c
  plot3d.c
  plpage.c
  plsdef.c
  plshade.c
  plstdio.c
  plstripc.c
  plsym.c
  pltick.c
  plvpor.c
  plwind.c
  plbuf.c
  plgridd.c
  plvect.c
  mt19937ar.c
  pltime.c
  pllegend.c
  )
if(PL_DEPRECATED)
  set(plplot${LIB_TAG}_LIB_SRCS ${plplot${LIB_TAG}_LIB_SRCS} pldeprecated.c)
endif(PL_DEPRECATED)
if(LTDL_WIN32)
  set(plplot${LIB_TAG}_LIB_SRCS ${plplot${LIB_TAG}_LIB_SRCS} ltdl_win32.c)
endif(LTDL_WIN32)

if(BUILD_SHARED_LIBS)
  SET_SOURCE_FILES_PROPERTIES(${plplot${LIB_TAG}_LIB_SRCS}
    PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
endif(BUILD_SHARED_LIBS)

option(HERSHEY_FALLBACK "Hershey fallback for Unicode fonts" ON)

if(NOT HERSHEY_FALLBACK)
  get_source_file_property(PLSYM_COMPILE_PROPS plsym.c COMPILE_FLAGS)
  if(NOT PLSYM_COMPILE_PROPS)
    set(PLSYM_COMPILE_PROPS)
  endif(NOT PLSYM_COMPILE_PROPS)
  set_source_files_properties(
    plsym.c
    PROPERTIES COMPILE_FLAGS "${PLSYM_COMPILE_PROPS} -DPL_TEST_FOR_MISSING_GLYPHS"
    )
endif(NOT HERSHEY_FALLBACK)

if(ENABLE_DYNDRIVERS)
  get_source_file_property(PLCORE_COMPILE_PROPS plcore.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLCORE_COMPILE_PROPS)
    set(PLCORE_COMPILE_PROPS)
  endif(NOT PLCORE_COMPILE_PROPS)
  set_source_files_properties(
    plcore.c
    PROPERTIES COMPILE_FLAGS "${PLCORE_COMPILE_PROPS} -I${LTDL_INCLUDE_DIR}"
    )
else(ENABLE_DYNDRIVERS)
  if(ENABLE_tcl)
    set(
      tclgenfiles
      ${CMAKE_BINARY_DIR}/bindings/tcl/tclgen.h
      ${CMAKE_BINARY_DIR}/bindings/tcl/tclgen_s.h
      ${CMAKE_BINARY_DIR}/bindings/tcl/tclgen.c
      )

    # Only need to set up this special command if either the tk and tkwin
    # non-dynamic devices are enabled (see below) since at build time
    # this special command is only fired in that case.
    add_custom_command(
      OUTPUT ${tclgenfiles}
      COMMAND ${TCL_TCLSH}
      ${CMAKE_SOURCE_DIR}/bindings/tcl/pltclgen.tcl
      ${CMAKE_SOURCE_DIR}/bindings/tcl
      DEPENDS
      ${CMAKE_SOURCE_DIR}/bindings/tcl/pltclgen.tcl
      ${CMAKE_SOURCE_DIR}/bindings/tcl/plapi.tpl
      ${CMAKE_SOURCE_DIR}/bindings/tcl/tclcmd.tpl
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bindings/tcl
      )
  endif(ENABLE_tcl)

  # Static device drivers must be included in the core PLplot library.
  set(DRIVERS_RPATH)
  foreach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
    #message("${SOURCE_ROOT_NAME}_SOURCE = ${${SOURCE_ROOT_NAME}_SOURCE}")
    list(APPEND plplot${LIB_TAG}_LIB_SRCS ${${SOURCE_ROOT_NAME}_SOURCE})
    if(SOURCE_ROOT_NAME STREQUAL "qt")
      if(ANY_QT_DEVICE)
	# For this case libplot must have a target dependency on the
	# moc files generated in the binary include directory.
	set(qt_dependency moc_outfile_generated)

	if(NOT QT_LIBRARIES)
	  message(FATAL_ERROR "include(${QT_USE_FILE}) failed in src subdirectory.")
	endif(NOT QT_LIBRARIES)
	set(DRIVERS_LINK_FLAGS ${DRIVERS_LINK_FLAGS} ${QT_LIBRARIES})
	
      else(ANY_QT_DEVICE)
	message(FATAL_ERROR "Internal build system inconsistency.  Attempt to build static qt device when ANY_QT_DEVICE is false.")
      endif(ANY_QT_DEVICE)
    endif(SOURCE_ROOT_NAME STREQUAL "qt")
    
    # qt device driver code within libplplot has some symbols that need to be
    # visible for qt_example in installed examples/c++ directory to link 
    # properly. 
    if(BUILD_SHARED_LIBS AND SOURCE_ROOT_NAME STREQUAL "qt")
      set(${SOURCE_ROOT_NAME}_COMPILE_FLAGS "${${SOURCE_ROOT_NAME}_COMPILE_FLAGS} -DUSINGDLL")
    endif(BUILD_SHARED_LIBS AND SOURCE_ROOT_NAME STREQUAL "qt")

    if(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS}
	)
      set(libplplot${LIB_TAG}_COMPILE_FLAGS
	${libplplot${LIB_TAG}_COMPILE_FLAGS}
	${${SOURCE_ROOT_NAME}_COMPILE_FLAGS}
	)
      if(SOURCE_ROOT_NAME STREQUAL "tk")
        set_source_files_properties(
	  ${${SOURCE_ROOT_NAME}_SOURCE}
	  PROPERTIES OBJECT_DEPENDS ${tclgenfiles}
	  )
      endif(SOURCE_ROOT_NAME STREQUAL "tk")
      if(SOURCE_ROOT_NAME STREQUAL "tkwin")
        set_source_files_properties(
	  ${${SOURCE_ROOT_NAME}_SOURCE}
	  PROPERTIES OBJECT_DEPENDS ${tclgenfiles}
	  )
      endif(SOURCE_ROOT_NAME STREQUAL "tkwin")
    endif(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
    if(${SOURCE_ROOT_NAME}_RPATH)
      set(DRIVERS_RPATH ${DRIVERS_RPATH} ${${SOURCE_ROOT_NAME}_RPATH})
    endif(${SOURCE_ROOT_NAME}_RPATH)
  endforeach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
endif(ENABLE_DYNDRIVERS)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/lib/qsastime
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/include
  )
add_library(plplot${LIB_TAG} ${plplot${LIB_TAG}_LIB_SRCS})
add_dependencies(plplot${LIB_TAG} plhershey-unicode.h_built ${qt_dependency})

if(NON_TRANSITIVE)
  # empty list ==> non-transitive linking for everything that links to
  # libplplotd in the shared libraries case.
  target_link_libraries(plplot${LIB_TAG} LINK_INTERFACE_LIBRARIES)
  # This configures the pkg-config method to use non-transitive linking.
  set(PC_REQUIRES_TAG "Requires.private")
else(NON_TRANSITIVE)
  # This configures the pkg-config method to use transitive linking
  set(PC_REQUIRES_TAG "Requires")
endif(NON_TRANSITIVE)

# Deal with external libraries.
set(LIB_INSTALL_RPATH ${LIB_DIR})
set(libplplot${LIB_TAG}_LINK_LIBRARIES)
if(ENABLE_DYNDRIVERS)
  list(APPEND libplplot${LIB_TAG}_LINK_LIBRARIES ${LTDL_LIBRARIES})
  #message("libplplot${LIB_TAG}_LINK_LIBRARIES =  ${libplplot${LIB_TAG}_LINK_LIBRARIES}")
  #message("libplplot${LIB_TAG}_RPATH = ${libplplot${LIB_TAG}_RPATH}")
  list(APPEND LIB_INSTALL_RPATH ${libplplot${LIB_TAG}_RPATH})
else(ENABLE_DYNDRIVERS)
  list(APPEND libplplot${LIB_TAG}_LINK_LIBRARIES ${DRIVERS_LINK_FLAGS})
  list(APPEND LIB_INSTALL_RPATH ${DRIVERS_RPATH})
  if(ANY_QT_DEVICE)
    # Update the target COMPILE_DEFINITIONS and INCLUDE_DIRECTORIES
    set_qt_target_properties(plplot${LIB_TAG})
  endif(ANY_QT_DEVICE)
endif(ENABLE_DYNDRIVERS)
#message("DEBUG: LIB_INSTALL_RPATH = ${LIB_INSTALL_RPATH}")

if(MATH_LIB)
  list(APPEND libplplot${LIB_TAG}_LINK_LIBRARIES ${MATH_LIB})
endif(MATH_LIB)

# Transform "${libplplot${LIB_TAG}_LINK_LIBRARIES}" string to the 
# standard pkg-config form.

if(HAVE_SHAPELIB)
  get_source_file_property(PLMAP_COMPILE_PROPS plmap.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLMAP_COMPILE_PROPS)
    set(PLMAP_COMPILE_PROPS)
  endif(NOT PLMAP_COMPILE_PROPS)
  set_source_files_properties(plmap.c 
    PROPERTIES
    COMPILE_FLAGS "${PLMAP_COMPILE_PROPS} -I${SHAPELIB_INCLUDE_DIR}"
    )
  if(HAVE_SAHOOKS)
  set_source_files_properties(plmap.c 
    PROPERTIES
    COMPILE_DEFINITIONS HAVE_SAHOOKS
    )
  endif(HAVE_SAHOOKS)

  list(APPEND libplplot${LIB_TAG}_LINK_LIBRARIES ${SHAPELIB_LIBRARIES})
  list(APPEND LIB_INSTALL_RPATH ${SHAPELIB_RPATH})

endif(HAVE_SHAPELIB)

if(WITH_FREETYPE)
  get_source_file_property(PLFREETYPE_COMPILE_PROPS plfreetype.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLFREETYPE_COMPILE_PROPS)
    set(PLFREETYPE_COMPILE_PROPS)
  endif(NOT PLFREETYPE_COMPILE_PROPS)
  set_source_files_properties(plfreetype.c PROPERTIES COMPILE_FLAGS "${PLFREETYPE_COMPILE_PROPS} -I${FREETYPE_INCLUDE_DIR}")
  list(APPEND libplplot${LIB_TAG}_LINK_LIBRARIES ${FREETYPE_LIBRARIES})
  
endif(WITH_FREETYPE)

set(libstdcxx_full_path)
if(ENABLE_cxx AND NOT BUILD_SHARED_LIBS)
  # For this special case where the plplot library is a static C++
  # library, pkg-config needs to add -L and -l options corresponding
  # to libstd++.so to the link flags it delivers.  Another alternative
  # is to have the plplot library link statically to libstd++.a, but
  # static linking is not well-supported in CMake, and I am attempting
  # to keep this fix limited to just the configuration of the
  # plplotd.pc pkg-config file.  N.B. the logic below for finding the
  # C++ library is extremely specific to GNU g++ (either Unix or MinGW
  # version), but it is good to get at least this compiler to work for
  # the special case of a static C++ plplot library.
  if(EXISTS "${CMAKE_CXX_COMPILER}")
    execute_process(
      COMMAND ${CMAKE_CXX_COMPILER} --verbose --version
      RESULT_VARIABLE CXX_rc
      ERROR_VARIABLE CXX_string
      ERROR_STRIP_TRAILING_WHITESPACE
      OUTPUT_QUIET
      )
  else(EXISTS "${CMAKE_CXX_COMPILER}")
    set(CXX_rc 2)
  endif(EXISTS "${CMAKE_CXX_COMPILER}")
  if(CXX_rc STREQUAL "0" AND CXX_string MATCHES "LIBRARY_PATH=")
    string(REGEX REPLACE "^.*(LIBRARY_PATH=.*)\nCOLLECT_GCC_OPTIONS.*$" "\\1"
      CXX_library_path_string "${CXX_string}"
      )
    #message(STATUS "CXX_library_path_string = ${CXX_library_path_string}")
    if(CXX_library_path_string MATCHES "^LIBRARY_PATH=")
      string(REGEX REPLACE "^LIBRARY_PATH=" "" CXX_library_path "${CXX_library_path_string}")
      # For both Linux and MinGW, CXX_library_path is a semicolon
      # delimited list which is identical to the form of a CMake list.
      # Furthermore, for the MinGW case, the drive letters are in the
      # colon form, but experiments show that is exactly the form
      # required by find_library for the MinGW case.  Net result: no
      # conversion necessary for either Linux or MinGW.
      find_library(libstdcxx_full_path NAMES stdc++ PATHS ${CXX_library_path})
      message(STATUS "libstdcxx_full_path = ${libstdcxx_full_path}")
    else(CXX_library_path_string MATCHES "^LIBRARY_PATH=")
      message(STATUS "WARNING: execute_process failed to obtain C++ library needed for pkg-config")
      message(STATUS "CXX_string = ${CXX_string}")
      message(STATUS "CXX_library_path_string = ${CXX_library_path_string}")
    endif(CXX_library_path_string MATCHES "^LIBRARY_PATH=")
  else(CXX_rc STREQUAL "0" AND CXX_string MATCHES "LIBRARY_PATH=")
    message(STATUS "WARNING: execute_process failed to obtain C++ library needed for pkg-config")
    message(STATUS "CMAKE_CXX_COMPILER = ${CMAKE_CXX_COMPILER}")
    message(STATUS "CXX_rc = ${CXX_rc}")
    message(STATUS "CXX_string = ${CXX_string}")
  endif(CXX_rc STREQUAL "0" AND CXX_string MATCHES "LIBRARY_PATH=")
  if(NOT libstdcxx_full_path)
    message(STATUS "WARNING: failed to find libstdc++ so pkg-config link flags will be incomplete") 
  endif(NOT libstdcxx_full_path)
endif(ENABLE_cxx AND NOT BUILD_SHARED_LIBS)

# Transform current information in libplplot${LIB_TAG}_LINK_LIBRARIES
# into pkg-config (libplplot${LIB_TAG}_LINK_FLAGS) form.  Both variables
# will have data added to them afterward due to the internal PLplot libraries
# which have a different pkg-config treatment than the external libraries
# dealt with here.

if(libstdcxx_full_path)
  pkg_config_link_flags(
    libplplot${LIB_TAG}_LINK_FLAGS
    "${libplplot${LIB_TAG}_LINK_LIBRARIES};${libstdcxx_full_path}"
  )
else(libstdcxx_full_path)
  pkg_config_link_flags(
    libplplot${LIB_TAG}_LINK_FLAGS
    "${libplplot${LIB_TAG}_LINK_LIBRARIES}"
  )
endif(libstdcxx_full_path)

=== bindings/c++/CMakeLists.txt ===
# bindings/c++/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Andrew Ross
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_cxx)

  set(plplotcxx${LIB_TAG}_LIB_SRCS
    plstream.cc
    )

  set(plplotcxx${LIB_TAG}_INSTALLED_HEADERS
    plstream.h
    )

  # Set the include path
  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )

  # Create plplotcxx[d] library
  add_library(plplotcxx${LIB_TAG} ${plplotcxx${LIB_TAG}_LIB_SRCS})

  if(BUILD_SHARED_LIBS)
    SET_SOURCE_FILES_PROPERTIES(${plplotcxx${LIB_TAG}_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)

  target_link_libraries(plplotcxx${LIB_TAG} plplot${LIB_TAG})
  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links
    # to libplplotcxx in the shared libraries case.
    target_link_libraries(plplotcxx${LIB_TAG} LINK_INTERFACE_LIBRARIES)
    # This configures the pkg-config method to use non-transitive linking.
    set(PC_REQUIRES_TAG "Requires.private")
  else(NON_TRANSITIVE)
    # This configures the pkg-config method to use transitive linking
    set(PC_REQUIRES_TAG "Requires")
  endif(NON_TRANSITIVE)

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    set_target_properties(plplotcxx${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotcxx_SOVERSION}
      VERSION ${plplotcxx_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotcxx${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotcxx_SOVERSION}
      VERSION ${plplotcxx_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)
  # Install library in lib/
  install(TARGETS plplotcxx${LIB_TAG}
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )
  install(FILES
    ${plplotcxx${LIB_TAG}_INSTALLED_HEADERS}
    DESTINATION ${INCLUDE_DIR}
    )

  # Configure pkg-config *.pc file corresponding to libplplotcxx${LIB_TAG}
  if(PKG_CONFIG_EXECUTABLE)
    if(LIB_TAG)
      set(PC_PRECISION "double")
    else(LIB_TAG)
      set(PC_PRECISION "single")
    endif(LIB_TAG)
    # Each list element must consist of a colon-separated string with the
    # following fields which are parsed out in the foreach loop below and
    # used to configure the corresponding pkg-config *.pc file.
    # BINDING 	      	  - ENABLE_${BINDING} keeps track of whether a
    # 			    binding has been enabled (ON) or not (OFF).
    #			    Also, ${BINDING} used to determine PC_FILE_SUFFIX
    #			    which helps to determine name of configured 
    #			    *.pc file.
    # PC_SHORT_NAME	  - Used in *.pc NAME: field
    # PC_LONG_NAME	  - Used in *.pc Description: field
    # PC_LIBRARY_NAME	  - Used in *.pc Libs: field
    #                         Also used to determine PC_LINK_FLAGS and
    #                         PC_COMPILE_FLAGS used in *.pc Libs: and Cflags:
    #			    fields.
    set(PC_DATA "c++:C++:C++ bindings, :plplotcxx${LIB_TAG}")

    string(REGEX REPLACE "^(.*):.*:.*:.*$" "\\1" BINDING ${PC_DATA})
    set(PC_FILE_SUFFIX "-${BINDING}")
    set(PC_REQUIRES "plplot${LIB_TAG}")
    string(REGEX REPLACE "^.*:(.*):.*:.*$" "\\1" PC_SHORT_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:(.*):.*$" "\\1" PC_LONG_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:.*:(.*)$" "\\1" PC_LIBRARY_NAME ${PC_DATA})
    set(PC_LINK_FLAGS "${lib${PC_LIBRARY_NAME}_LINK_FLAGS}")
    set(PC_COMPILE_FLAGS "${lib${PC_LIBRARY_NAME}_COMPILE_FLAGS}")
    set(PC_LINK_FLAGS "-l${PC_LIBRARY_NAME} ${PC_LINK_FLAGS}")
    set(PC_CONFIGURED_FILE
      ${CMAKE_BINARY_DIR}/pkgcfg/plplot${LIB_TAG}${PC_FILE_SUFFIX}.pc
      )
    configure_file(
      ${CMAKE_SOURCE_DIR}/pkgcfg/plplot-template.pc.in
      ${PC_CONFIGURED_FILE}
      @ONLY
      )
    install(FILES ${PC_CONFIGURED_FILE} DESTINATION ${PKG_CONFIG_DIR})
  endif(PKG_CONFIG_EXECUTABLE)
endif(ENABLE_cxx)

=== bindings/f95/CMakeLists.txt ===
# bindings/f95/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Andrew Ross
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_f95)

  # Set the include path
  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    )

  # Configure the Fortran include file that specifies the kind of
  # floating-point (single vs double) PLplot supports.
  if(PL_DOUBLE)
    set(ONE_IN_DEFAULT_PRECISION "1.0d0")
  else(PL_DOUBLE)
    set(ONE_IN_DEFAULT_PRECISION "1.0")
  endif(PL_DOUBLE)

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/plflt.inc.in
    ${CMAKE_CURRENT_BINARY_DIR}/plflt.inc
    @ONLY
    )

  ## Build C part of F95 bindings
  if(WIN32_OR_CYGWIN)
    # Set the flags for the C compiler. The C stubs need to have the
    # correct case and calling convention for the Fortran compiler
    IF(TARGET_FORTRAN MATCHES "IVF")
      SET(DEFFILE "_ifort")
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /DIVF")
    ELSEIF(TARGET_FORTRAN MATCHES "CVF")
      SET(DEFFILE "")
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /DCVF")
    ENDIF(TARGET_FORTRAN MATCHES "IVF")
  endif(WIN32_OR_CYGWIN)

  set(plplotf95c${LIB_TAG}_LIB_SRCS
    sc3d.c
    sccont.c
    scstubs.c
    )

  if(BUILD_SHARED_LIBS)
    SET_SOURCE_FILES_PROPERTIES(${plplotf95c${LIB_TAG}_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)

  add_library(plplotf95c${LIB_TAG} ${plplotf95c${LIB_TAG}_LIB_SRCS})

  target_link_libraries(plplotf95c${LIB_TAG}  plplot${LIB_TAG})

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    set_target_properties(plplotf95c${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotf95c${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)

  install(TARGETS plplotf95c${LIB_TAG}
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  # Build fortran part of F95 bindings.
  # Notes:

  # configurable.f90 is actually not currently configurable.

  # The CMake Fortran dependency scanner finds the Fortran include
  # file, sfstub.h, and the configured Fortran include file,
  # ${CMAKE_CURRENT_BINARY_DIR}/plflt.inc, and also deals properly with
  # the dependencies on those files.  Therefore, there is no need to
  # include those files in the SRCS list or do anything special with
  # their dependencies.

  # Check consistency of plplot_parameters.h.
  add_custom_target(
    check_f95_parameters
    COMMAND ${CMAKE_COMMAND} -E remove -f 
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.h_compare
    COMMAND
    sed -f ${CMAKE_CURRENT_SOURCE_DIR}/global_defines.sed < 
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i > 
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.h_compare
    COMMAND
    ${CMAKE_COMMAND} -E echo "Check that plplot_parameters.h is consistent with the #defines in bindings/swig-support/plplotcapi.i"
    COMMAND
    cmp ${CMAKE_CURRENT_SOURCE_DIR}/plplot_parameters.h
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.h_compare
    )

  set(plplotf95${LIB_TAG}_LIB_SRCS
    strutil.f90
    configurable.f90
    sfstubsf95.f90
    )

  if(WIN32_AND_NOT_CYGWIN AND BUILD_SHARED_LIBS AND NOT MINGW)
    SET(plplotf95${LIB_TAG}_LIB_SRCS ${plplotf95${LIB_TAG}_LIB_SRCS} plplotf95${DEFFILE}.def)
  endif(WIN32_AND_NOT_CYGWIN AND BUILD_SHARED_LIBS AND NOT MINGW)

  add_library(plplotf95${LIB_TAG} ${plplotf95${LIB_TAG}_LIB_SRCS})

  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links to
    # libplplotf95cd and libplplotf95d in the shared libraries case.
    target_link_libraries(plplotf95c${LIB_TAG} LINK_INTERFACE_LIBRARIES)
    target_link_libraries(plplotf95${LIB_TAG} LINK_INTERFACE_LIBRARIES)
    # This configures the pkg-config method to use non-transitive linking.
    set(PC_REQUIRES_TAG "Requires.private")
  else(NON_TRANSITIVE)
    # This configures the pkg-config method to use transitive linking
    set(PC_REQUIRES_TAG "Requires")
  endif(NON_TRANSITIVE)

  target_link_libraries(plplotf95${LIB_TAG}  plplotf95c${LIB_TAG})

  if(USE_RPATH)
    set_target_properties(plplotf95${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotf95${LIB_TAG}
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)

  # Set the path and the suffix for the (shared) libraries
  if(CYGWIN)
    if(BUILD_SHARED_LIBS)
      set(SHLIB_DIR "${BIN_DIR}")
    endif(BUILD_SHARED_LIBS)
    set(VERSION_SUFFIX "-${plplotf95_VERSION}")
  else(CYGWIN)
    set(VERSION_SUFFIX "")
  endif(CYGWIN)

  install(TARGETS plplotf95${LIB_TAG}
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  # For CMake-2.6.0 and above, the module files are created by
  # default during the library build in the bindings/f95 directory.
  install(
    FILES
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplotp.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot_flt.mod
    DESTINATION ${F95_MOD_DIR}
    )

  # Configure pkg-config *.pc file corresponding to libplplotf95${LIB_TAG}
  if(PKG_CONFIG_EXECUTABLE)
    if(LIB_TAG)
      set(PC_PRECISION "double")
    else(LIB_TAG)
      set(PC_PRECISION "single")
    endif(LIB_TAG)
    # Each list element must consist of a colon-separated string with the
    # following fields which are parsed out in the foreach loop below and
    # used to configure the corresponding pkg-config *.pc file.
    # BINDING 	      	  - ENABLE_${BINDING} keeps track of whether a
    # 			    binding has been enabled (ON) or not (OFF).
    #			    Also, ${BINDING} used to determine PC_FILE_SUFFIX
    #			    which helps to determine name of configured
    #			    *.pc file.
    # PC_SHORT_NAME	  - Used in *.pc NAME: field
    # PC_LONG_NAME	  - Used in *.pc Description: field
    # PC_LIBRARY_NAME	  - Used in *.pc Libs: field
    #                         Also used to determine PC_LINK_FLAGS and
    #                         PC_COMPILE_FLAGS used in *.pc Libs: and Cflags:
    #			    fields.
    set(PC_DATA "f95:F95:F95 bindings, :plplotf95${LIB_TAG}${VERSION_SUFFIX}")

    string(REGEX REPLACE "^(.*):.*:.*:.*$" "\\1" BINDING ${PC_DATA})
    set(PC_FILE_SUFFIX "-${BINDING}")
    set(PC_REQUIRES "plplot${LIB_TAG}")
    string(REGEX REPLACE "^.*:(.*):.*:.*$" "\\1" PC_SHORT_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:(.*):.*$" "\\1" PC_LONG_NAME ${PC_DATA})
    string(REGEX REPLACE "^.*:.*:.*:(.*)$" "\\1" PC_LIBRARY_NAME ${PC_DATA})
    set(PC_LINK_FLAGS "${lib${PC_LIBRARY_NAME}_LINK_FLAGS}")
    set(PC_COMPILE_FLAGS "${lib${PC_LIBRARY_NAME}_COMPILE_FLAGS}")
    set(PC_LINK_FLAGS
      "-l${PC_LIBRARY_NAME} -lplplotf95c${LIB_TAG}${VERSION_SUFFIX} ${PC_LINK_FLAGS}"
      )
    set(PC_COMPILE_FLAGS "-I${F95_MOD_DIR} ${PC_COMPILE_FLAGS}")
    set(PC_CONFIGURED_FILE
      ${CMAKE_BINARY_DIR}/pkgcfg/plplot${LIB_TAG}${PC_FILE_SUFFIX}.pc
      )
    configure_file(
      ${CMAKE_SOURCE_DIR}/pkgcfg/plplot-template.pc.in
      ${PC_CONFIGURED_FILE}
      @ONLY
      )
    install(FILES ${PC_CONFIGURED_FILE} DESTINATION ${PKG_CONFIG_DIR})
  endif(PKG_CONFIG_EXECUTABLE)
endif(ENABLE_f95)

=== bindings/java/CMakeLists.txt ===
# bindings/java/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Andrew Ross
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_java)

  # Swig generated java files.  Order no longer matters since class 
  # dependencies are explicitly handled now.

  set(
    SWIG_JAVA_FILES
    plplotjavacJNI.java 
    PLGraphicsIn.java 
    plplotjavacConstants.java
    plplotjavac.java
    )

  # List of swig-generated + configured java files
  set(
    JAVA_GEN_FILES
    config.java
    ${SWIG_JAVA_FILES}
    )

  # List of swig-generated + configured java files with full path names
  # Need this otherwise cmake will look in the source directory for the
  # .java files.
  string(
    REGEX REPLACE "([a-zA-z]*)\\.java"
    "${CMAKE_CURRENT_BINARY_DIR}/\\1.java" 
    JAVA_GEN_FILES_FULL 
    "${JAVA_GEN_FILES}"
    )

  # Full pathnames for all java files.
  set(
    JAVA_FILES_FULL
    ${JAVA_GEN_FILES_FULL}
    ${CMAKE_CURRENT_SOURCE_DIR}/PLStream.java
    ${CMAKE_CURRENT_SOURCE_DIR}/PLCallbackMapform.java
    ${CMAKE_CURRENT_SOURCE_DIR}/PLCallbackLabel.java
    ${CMAKE_CURRENT_SOURCE_DIR}/PLCallbackCT.java

    )

  # Explicit full-path class dependencies for the foreach loop below which
  # should build classes in the correct order regardless of whether it
  # is a parallel build or not and regardless of the order of JAVA_FILES_FULL.
  # These are hand-crafted dependencies based on scanning the appropriate
  # Java sources.  Apparently CMake has a java dependency scanner which
  # might be good enough to do this task as well, but I have avoided it because
  # I (AWI) am under the impression that CMake support of java is still in its
  # infancy.

  set(class_root ${CMAKE_CURRENT_BINARY_DIR}/plplot/core)

  set(
    ${class_root}/plplotjavacJNI.class_DEPENDS
    ${class_root}/PLCallbackMapform.class
    ${class_root}/PLCallbackLabel.class
    ${class_root}/PLCallbackCT.class
    )

  set(
    ${class_root}/PLGraphicsIn.class_DEPENDS
    ${class_root}/plplotjavacJNI.class
    )

  set(
    ${class_root}/plplotjavacConstants.class_DEPENDS
    ${class_root}/plplotjavacJNI.class
    )

  set(
    ${class_root}/plplotjavac.class_DEPENDS
    ${class_root}/plplotjavacConstants.class
    ${class_root}/PLGraphicsIn.class
    ${class_root}/plplotjavacJNI.class
    ${class_root}/PLCallbackMapform.class
    ${class_root}/PLCallbackLabel.class
    ${class_root}/PLCallbackCT.class
    )

  set(
    ${class_root}/PLStream.class_DEPENDS
    ${class_root}/plplotjavacConstants.class
    ${class_root}/config.class
    ${class_root}/plplotjavac.class
    ${class_root}/PLCallbackMapform.class
    ${class_root}/PLCallbackLabel.class
    ${class_root}/PLCallbackCT.class
    )

  # This is currently the include list for swig, the C wrapper and the
  # the java classpath. Not particular pretty...
  set(java_interface_INCLUDE_PATHS
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${JAVA_INCLUDE_PATH}
    ${CMAKE_SOURCE_DIR}/bindings/swig-support
    )
  # On some systems JAVA_INCLUDE_PATH2 returns JAVA_INCLUDE_PATH2-NOTFOUND
  if(JAVA_INCLUDE_PATH2)
    set(java_interface_INCLUDE_PATHS
      ${java_interface_INCLUDE_PATHS}
      ${JAVA_INCLUDE_PATH2}
      )
  endif(JAVA_INCLUDE_PATH2)
  include_directories(${java_interface_INCLUDE_PATHS})

  # Can't use source file properties as we have to quote the flags in that 
  # case and it breaks swig. Doh! I would call this a cmake bug.
  if(SWIG_JAVA_NOPGCPP)
    #This version of swig supports the -nopgcpp option
    set(CMAKE_SWIG_FLAGS -DPL_DOUBLE_INTERFACE -DSWIG_JAVA -package plplot.core -nopgcpp)
  else(SWIG_JAVA_NOPGCPP)
    set(CMAKE_SWIG_FLAGS -DPL_DOUBLE_INTERFACE -DSWIG_JAVA -package plplot.core)
  endif(SWIG_JAVA_NOPGCPP)

  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

  # This may be needed in future when we use CMake java support to build the
  # class files, but it obviously is not correct now when we use custom commands
  # to build the class files using file dependencies to keep things straight.
  ## set_source_files_properties(${JAVA_GEN_FILES_FULL} PROPERTIES GENERATED ON)

  set(SWIG_MODULE_plplotjavac_wrap_EXTRA_DEPS
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i)

  set_source_files_properties(
    plplotjavac.i 
    PROPERTIES SWIG_MODULE_NAME plplotjavac
    )

  # Create swig-generated java files and swig-generated C wrapper source
  # code.  Also, build that source code into a shared object (a.k.a. plug-in)
  # that can be dynamically loaded by java.
  swig_add_module(plplotjavac_wrap java plplotjavac.i)
  # The shared object must be linked against the core PLplot library.
  swig_link_libraries(plplotjavac_wrap plplot${LIB_TAG})

  # Create config.java.  Other generated java files created by swig above.
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.java.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.java
    )

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    set_target_properties(
      plplotjavac_wrap
      PROPERTIES
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${JAVAWRAPPER_HARDDIR}"
      )
  else(USE_RPATH)
    set_target_properties(
      plplotjavac_wrap
      PROPERTIES
      INSTALL_NAME_DIR "${JAVAWRAPPER_HARDDIR}"
      )
  endif(USE_RPATH)

  # Ensure we get the correct suffix for OS-X 
  if(APPLE)
    set_target_properties(
      plplotjavac_wrap
      PROPERTIES
      SUFFIX ".dylib"
      )
  endif(APPLE)

  install(TARGETS plplotjavac_wrap LIBRARY DESTINATION ${JAVAWRAPPER_HARDDIR})

  set(JAVA_CLASSES)
  foreach( srcfile ${JAVA_FILES_FULL} )
    get_filename_component(fileroot ${srcfile} NAME_WE)
    set(output_file ${CMAKE_CURRENT_BINARY_DIR}/plplot/core/${fileroot}.class)
    list(APPEND JAVA_CLASSES ${output_file})
    add_custom_command(
      OUTPUT ${output_file}
      COMMAND ${CMAKE_Java_COMPILER} 
      ${JAVACFLAGS} -classpath ${CMAKE_CURRENT_BINARY_DIR} ${srcfile} -d ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${srcfile} ${${output_file}_DEPENDS}
      VERBATIM
      )
  endforeach( srcfile ${JAVA_FILES_FULL} )
  add_custom_target(plplot_core ALL DEPENDS ${JAVA_CLASSES})

  # Need to keep track of file dependencies since this is a custom target.
  set_property(GLOBAL PROPERTY FILES_plplot_core ${JAVA_CLASSES})

  # Ensure that swig is executed before we try to compile the java
  # classes which file-depend (see above custom_command DEPENDS) on
  # the java files created by swig (amongst others).
  add_dependencies(plplot_core plplotjavac_wrap)

  # Installed as part of the example/java directory
  #install(FILES ${CMAKE_BINARY_DIR}/plplot.jar DESTINATION ${JAR_DIR})

endif(ENABLE_java)

=== bindings/lua/CMakeLists.txt ===
# bindings/lua/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008  Werner Smekal
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_lua)

  # This is currently the include list for swig.
  set(lua_interface_INCLUDE_PATHS
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LUA_INCLUDE_DIR}
    ${CMAKE_SOURCE_DIR}/bindings/swig-support
    )
  include_directories(${lua_interface_INCLUDE_PATHS})

  set(CMAKE_SWIG_FLAGS -DSWIG_LUA)
  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

  set_source_files_properties(plplotluac.i 
    PROPERTIES SWIG_MODULE_NAME plplotluac
    )

  set(SWIG_MODULE_plplotluac_EXTRA_DEPS
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i)

  # Set up swig + c wrapper.
  swig_add_module(plplotluac lua plplotluac.i)
  swig_link_libraries(plplotluac plplot${LIB_TAG} ${LUA_LIBRARIES})

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    set_target_properties(
      plplotluac
      PROPERTIES
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LUA_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(
      plplotluac
      PROPERTIES
      INSTALL_NAME_DIR "${LUA_DIR}"
      )
  endif(USE_RPATH)

  # Ensure we get the correct suffix for OS-X 
  if(APPLE)
    set_target_properties(
      plplotluac
      PROPERTIES
      SUFFIX ".dylib"
      )
  endif(APPLE)

  install(TARGETS plplotluac
    EXPORT export_plplot
    LIBRARY
    DESTINATION ${LUA_DIR}
    )

endif(ENABLE_lua)

=== bindings/octave/CMakeLists.txt ===
# bindings/octave/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Build and install octave interface to PLplot and octave PLplot examples.
if(ENABLE_octave)

  add_subdirectory(PLplot)
  add_subdirectory(misc)

  # Install renamed documentation files.
  set(docfiles
    BUGS
    FGA
    INSTALL
    README
    ToDo
    USAGE
    )
  foreach(doc ${docfiles})
    install(FILES ${doc} DESTINATION ${DOC_DIR} RENAME ${doc}.octave)
  endforeach(doc ${docfiles})

  # This is a representative generated (or prebuilt) octave documentation file.
  # There are more than a hundred of these *.txt files.  If the (unlikely)
  # event that the plinit command is no longer part of the PLplot API, this
  # representative file would have to be changed.
  set(rep_doc plinit.txt)

  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/plplot_octave_txt/${rep_doc})
    # Octave documentation has been prebuilt in the (tarball) source tree.
    # Copy it to the build tree if that tree is different from source tree.
    if(NOT CMAKE_BINARY_DIR STREQUAL "${CMAKE_SOURCE_DIR}")
      add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/${rep_doc}
	COMMAND ${CMAKE_COMMAND} -E copy_directory
	${CMAKE_SOURCE_DIR}/bindings/octave/plplot_octave_txt
	${CMAKE_BINARY_DIR}/bindings/octave/plplot_octave_txt
	)
    endif(NOT CMAKE_BINARY_DIR STREQUAL "${CMAKE_SOURCE_DIR}")
    set(make_documentation_DEPENDS
      ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/${rep_doc}
      )
  else(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/plplot_octave_txt/${rep_doc})
    # Generate full on-line help for plplot_octave
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/plplot.doc
      COMMAND ${CMAKE_COMMAND} -E copy
      ${CMAKE_CURRENT_SOURCE_DIR}/etc/plplot.doc
      ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/plplot.doc
      DEPENDS
      ${CMAKE_CURRENT_SOURCE_DIR}/etc/plplot.doc
      )
    if(PERL_XML_DOM AND PERL_XML_PARSER)
      add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/${rep_doc}
	COMMAND ${PERL_EXECUTABLE}
	${CMAKE_SOURCE_DIR}/doc/docbook/bin/api2text.pl
	${CMAKE_SOURCE_DIR}/doc/docbook/src/plplotdoc.xml.in
	${CMAKE_SOURCE_DIR}/doc/docbook/src/api.xml
	DEPENDS 
	${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/plplot.doc
	${CMAKE_SOURCE_DIR}/doc/docbook/bin/api2text.pl
	${CMAKE_SOURCE_DIR}/doc/docbook/src/plplotdoc.xml.in
	${CMAKE_SOURCE_DIR}/doc/docbook/src/api.xml
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt
	)
      
      set(make_documentation_DEPENDS
	${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/${rep_doc}
	)
    else(PERL_XML_DOM AND PERL_XML_PARSER)
      message(STATUS 
	"WARNING: Perl modules XML::Parser and/or XML::DOM not available\n"
	"   so cannot generate full online help for plplot_octave"
	)
      set(make_documentation_DEPENDS
	${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/plplot.doc
	)
    endif(PERL_XML_DOM AND PERL_XML_PARSER)
  endif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/plplot_octave_txt/${rep_doc})

  add_custom_target(
    make_documentation ALL
    DEPENDS ${make_documentation_DEPENDS}
    )

  # Configure source code for octave interface to PLplot.
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/plplot_octave.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave.h
    @ONLY
    )
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/octave_version.pl.in
    ${CMAKE_CURRENT_BINARY_DIR}/octave_version.pl
    @ONLY
    )
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/octaverc.in
    ${CMAKE_CURRENT_BINARY_DIR}/.octaverc
    @ONLY
    )

  # Build octave interface.
  add_custom_command(
    OUTPUT 
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_stub.m
    COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/plplot_stub_hand_crafted.m
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_stub.m
    DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/plplot_stub_hand_crafted.m
    )

  add_custom_target(
    plplot_stub.m_built ALL
    DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_stub.m
    )

  set(octave_interface_INCLUDE_PATHS
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_CURRENT_BINARY_DIR}
    ${OCTAVE_INCLUDE_PATH}
    ${CMAKE_SOURCE_DIR}/bindings/swig-support
    )
  include_directories(${octave_interface_INCLUDE_PATHS})
  set(CMAKE_SWIG_FLAGS -DSWIG_OCTAVE)
  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

  set_source_files_properties(plplot_octave.i 
    PROPERTIES 
    SWIG_MODULE_NAME plplot_octave
    CPLUSPLUS ON
    )

  set(SWIG_MODULE_plplot_octave_EXTRA_DEPS
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/swig_documentation.i
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i
    )

  # Set up swig + c wrapper.
  swig_add_module(plplot_octave octave plplot_octave.i)
  swig_link_libraries(
    plplot_octave 
    plplot${LIB_TAG}
    "${OCTAVE_LIBRARIES}"
    "${OCTINTERP_LIBRARIES}"
    )

  # Make sure plplot_stub.m is copied to build tree before plplot_octave
  # is created so can use plplot_octave in normal way.
  add_dependencies(plplot_octave plplot_stub.m_built)

  # Need access elsewhere (examples/octave) to the file depends of
  # this custom target.
  set_property(GLOBAL PROPERTY 
    FILES_plplot_stub.m_built
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_stub.m
    )

  install(FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_stub.m
    DESTINATION ${PLPLOT_OCTAVE_DIR}
    )

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    # (Reasonable) assumption here is that OCTAVE_LIBRARIES and
    # OCTINTERP_LIBRARIES have the same path.
    get_filename_component(OCTAVE_INSTALL_RPATH "${OCTAVE_LIBRARIES}" PATH)
    set(LIB_INSTALL_RPATH ${LIB_INSTALL_RPATH} ${OCTAVE_INSTALL_RPATH})
    set_target_properties(
      plplot_octave
      PROPERTIES
      PREFIX "" 
      SUFFIX ".oct"
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${OCTAVE_OCT_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(
      plplot_octave
      PROPERTIES
      PREFIX "" 
      SUFFIX ".oct"
      INSTALL_NAME_DIR "${OCTAVE_OCT_DIR}"
      )
  endif(USE_RPATH)

  # Have to be specific about permissions for some reason (probably
  # oct suffix).  Use SO_PERMISSIONS to be consistent with permissions
  # used for other shared objects created by the add_library command.

  install(TARGETS plplot_octave
    EXPORT export_plplot
    LIBRARY
    DESTINATION ${OCTAVE_OCT_DIR}
    PERMISSIONS ${SO_PERMISSIONS}
    )

endif(ENABLE_octave)

=== bindings/python/CMakeLists.txt ===
# bindings/python/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_python)

  # This is currently the include list for swig, the C wrapper and the
  # the Python headers. Not particular pretty...
  if(ENABLE_tkX)
    set(python_interface_INCLUDE_PATHS
      ${CMAKE_SOURCE_DIR}/include
      ${CMAKE_SOURCE_DIR}/lib/qsastime
      ${CMAKE_SOURCE_DIR}/bindings/tcl
      ${CMAKE_SOURCE_DIR}/bindings/tk
      ${CMAKE_BINARY_DIR}
      ${CMAKE_BINARY_DIR}/include
      ${CMAKE_CURRENT_BINARY_DIR}
      ${TCL_INCLUDE_PATH}
      ${PYTHON_INCLUDE_PATH}
      ${NUMPY_INCLUDE_PATH}
      ${CMAKE_SOURCE_DIR}/bindings/swig-support
      )
  else(ENABLE_tkX)
    set(python_interface_INCLUDE_PATHS
      ${CMAKE_SOURCE_DIR}/include
      ${CMAKE_SOURCE_DIR}/lib/qsastime
      ${CMAKE_BINARY_DIR}
      ${CMAKE_BINARY_DIR}/include
      ${CMAKE_CURRENT_BINARY_DIR}
      ${PYTHON_INCLUDE_PATH}
      ${NUMPY_INCLUDE_PATH}
      ${CMAKE_SOURCE_DIR}/bindings/swig-support
      )
  endif(ENABLE_tkX)
  include_directories(${python_interface_INCLUDE_PATHS})

  if(PL_DOUBLE)
    set(CMAKE_SWIG_FLAGS -DPL_DOUBLE_INTERFACE -DSWIG_PYTHON)
  else(PL_DOUBLE)
    set(CMAKE_SWIG_FLAGS -DSWIG_PYTHON)
  endif(PL_DOUBLE)

  if(PYTHON_HAVE_PYBUFFER)
    set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -DPYTHON_HAVE_PYBUFFER)
  endif(PYTHON_HAVE_PYBUFFER)

  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

  set(SWIG_MODULE_plplotcmodule_EXTRA_DEPS
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/swig_documentation.i
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i
    )

  set_source_files_properties(plplotcmodule.i 
    PROPERTIES SWIG_MODULE_NAME plplotc
    )

  # Set up swig + c wrapper.
  # N.B. the python target has an underscore prepended automatically.
  swig_add_module(plplotcmodule python plplotcmodule.i)

  swig_link_libraries(plplotcmodule plplot${LIB_TAG} ${PYTHON_LIBRARIES})

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot${LIB_TAG} INSTALL_RPATH)
    set_target_properties(
      _plplotcmodule
      PROPERTIES
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      )
  endif(USE_RPATH)

  if(WIN32_AND_NOT_CYGWIN)
    set_target_properties(
      _plplotcmodule
      PROPERTIES
      SUFFIX ".pyd"
      OUTPUT_NAME "_plplotc"
      )
  elseif(CYGWIN)
    set_target_properties(
      _plplotcmodule
      PROPERTIES
      SUFFIX ".dll"
      OUTPUT_NAME "_plplotc"
      )  
  endif(WIN32_AND_NOT_CYGWIN)

  add_library(plplot_widgetmodule MODULE plplot_widgetmodule.c)
  set_target_properties(plplot_widgetmodule PROPERTIES PREFIX "")
  set_source_files_properties( 
    plplot_widgetmodule.c 
    PROPERTIES COMPILE_FLAGS
    "-DUSINGDLL"
    )

  if(ENABLE_tkX)
    target_link_libraries( plplot_widgetmodule
      plplot${LIB_TAG}
      plplottcltk${LIB_TAG}
      ${PYTHON_LIBRARIES}
      )
  else(ENABLE_tkX)
    target_link_libraries( plplot_widgetmodule
      plplot${LIB_TAG}
      ${PYTHON_LIBRARIES}
      )
  endif(ENABLE_tkX)

  if(USE_RPATH)
    set_target_properties(
      plplot_widgetmodule
      PROPERTIES
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${PYTHON_INSTDIR}"
      )
  else(USE_RPATH)
    set_target_properties(
      plplot_widgetmodule
      PROPERTIES
      INSTALL_NAME_DIR "${PYTHON_INSTDIR}"
      )
  endif(USE_RPATH)

  install(
    TARGETS plplot_widgetmodule _plplotcmodule
    EXPORT export_plplot
    LIBRARY 
    DESTINATION ${PYTHON_INSTDIR}
    )

  set(PERM_SCRIPTS
    OWNER_READ
    OWNER_WRITE
    OWNER_EXECUTE
    GROUP_READ
    GROUP_EXECUTE
    WORLD_READ
    WORLD_EXECUTE
    )
  install(
    FILES plplot.py ${CMAKE_CURRENT_BINARY_DIR}/plplotc.py
    DESTINATION ${PYTHON_INSTDIR}
    )
  if(ENABLE_tkX)
    install(
      FILES
      Plframe.py TclSup.py
      DESTINATION ${PYTHON_INSTDIR}
      )
  endif(ENABLE_tkX)

endif(ENABLE_python)

=== bindings/swig-support/CMakeLists.txt ===
# bindings/swig-support/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2010 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Add (Unix) custom target to check that swig_documentation.i is up to
# date with our DocBook api chapter
if(PERL_XML_DOM AND PERL_XML_PARSER)
  add_custom_target(
    check_swig_documentation
    COMMAND ${CMAKE_COMMAND} -E remove -f
    ${CMAKE_CURRENT_BINARY_DIR}/swig_documentation.i_compare
    COMMAND ${PERL_EXECUTABLE}
    ${CMAKE_SOURCE_DIR}/doc/docbook/bin/api2swigdoc.pl
    ${CMAKE_SOURCE_DIR}/doc/docbook/src/plplotdoc.xml.in
    ${CMAKE_SOURCE_DIR}/doc/docbook/src/api.xml
    ${CMAKE_CURRENT_BINARY_DIR}/swig_documentation.i_compare
    COMMAND ${CMAKE_COMMAND} -E echo "Check that swig_documentation.i is consistent with doc/docbook/src/api.xml"
    COMMAND cmp 
    ${CMAKE_CURRENT_SOURCE_DIR}/swig_documentation.i
    ${CMAKE_CURRENT_BINARY_DIR}/swig_documentation.i_compare
    )
  
  set(make_documentation_DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_txt/${rep_doc}
    )
else(PERL_XML_DOM AND PERL_XML_PARSER)
  message(STATUS 
    "WARNING: Perl modules XML::Parser and/or XML::DOM not available\n"
    "   so cannot check that swig_documentation.i is up to date."
    )
endif(PERL_XML_DOM AND PERL_XML_PARSER)

# Add (Unix) custom target to check numerical #defines in plplotcapi.i.
add_custom_target(
  check_plplotcapi_defines
  COMMAND ${CMAKE_COMMAND} -E remove -f
  ${CMAKE_CURRENT_BINARY_DIR}/generated_plplotcapi_defines
  COMMAND grep -E "^ *#define +[^ ]+ +[()-+0-9x]+" ${CMAKE_SOURCE_DIR}/include/plplot.h | grep -v plotsh3d > ${CMAKE_CURRENT_BINARY_DIR}/generated_plplotcapi_defines
  COMMAND ${CMAKE_COMMAND} -E echo "Non-NULL diff results below (which will be accompanied by an error for this target) imply the numerical #defines section of bindings/swig-support/plplotcapi.i needs updating following the directions in that file"
  COMMAND grep -E "^ *#define +[^ ]+ +[()-+0-9x]+" ${CMAKE_CURRENT_SOURCE_DIR}/plplotcapi.i | diff -auw - ${CMAKE_CURRENT_BINARY_DIR}/generated_plplotcapi_defines
  VERBATIM
)

=== debian/changelog ===
plplot (5.10.0+dfsg2-0.4ubuntu1) zesty; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Honour nocheck in DEB_BUILD_OPTIONS.
    - Enable verbose builds and tests.
    - Remove multiarch path in pkgconfig files.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Mon, 09 Jan 2017 08:53:58 +0530

plplot (5.10.0+dfsg2-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with cmake >= 3.6.2. Closes: #835708

 -- Ole Streicher <olebole@debian.org>  Tue, 20 Sep 2016 09:12:35 +0200

plplot (5.10.0+dfsg2-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with "dpkg-buildpackage -A" by letting build-indep-stamp
    depend on config-stamp in debian/rules. (Closes: #816987)

 -- Axel Beckert <abe@debian.org>  Wed, 03 Aug 2016 21:18:45 +0200

plplot (5.10.0+dfsg2-0.2ubuntu1) yakkety; urgency=medium

  * Merge with Debian; remaining changes:
    - Honor nocheck in DEB_BUILD_OPTIONS.
    - Enable verbose builds and tests.
    - Remove multiarch path in pkgconfig files.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 May 2016 20:38:36 +0200

plplot (5.10.0+dfsg2-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch enabling/disabling of D and Octave support to slice +
    debian/control.in instead of commenting. Allow to disable ADA support
    completely (not only for sh4) that way, too.
  * Disable ADA and D support which currently FTBFS. (Closes: #809592)
  * Update debian/control from debian/control.in with "debian/rules
    control".
  * Replace out-dated debian/README.source with according instructions.

 -- Axel Beckert <abe@debian.org>  Tue, 16 Feb 2016 22:32:30 +0100

plplot (5.10.0+dfsg2-0.1ubuntu2) xenial; urgency=medium

  * Rebuild for ocaml ABI changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 13:20:22 +0100

plplot (5.10.0+dfsg2-0.1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Honor nocheck in DEB_BUILD_OPTIONS.
    - Enable verbose builds and tests.
    - Remove multiarch path in pkgconfig files.
  * Dropped changes, included in Debian:
    - Apply work-arounds from Debian #789619 to fix the ftbfs.
  * Dropped changes:
    - debian/libplplot-lua.files: don't diverge from Debian, we stopped trying
      to build against lua5.2 in vivid (why?) so don't need to carry a delta
      just to match on non-lua5.1 files.
    - drop disabling of octave tests, which shouldn't run when the octave
      frontend isn't configured.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 01 Nov 2015 15:29:48 -0800

plplot (5.10.0+dfsg2-0.1) unstable; urgency=low

  [ Axel Beckert ]
  * Non-maintainer upload.
  * Repack upstream tarball to no more include non-free image lena.*.
    + Add patch to remove handling of lena images from multiple files.
    + Add according Files-Excluded header to debian/copyright.
    + Fixes lintian-reported error license-problem-non-free-img-lenna.
    + Closes: #794857
  * debian/copyright: Add missing path element in URL in Source field.
    Issue found by DUCK.
  * Add build-dependency on dh-python to fix FTBFS in
    bindings/python/CMakeFiles/plplot_widgetmodule.dir/plplot_widgetmodule.c.o.

  [ Peter Michael Green ]
  * Apply upstream patch to fix build with cmake 3.1 (Closes: #789619)
  * Disable octave support as it's currently broken
    + see my post to bug #789619 for further info on the error
    + debian/rules and debian/control changes adapted from 5.10.0-0ubuntu5
      package by Matthias Klose
    + also moved liboctave-dev build-depends to build-conflicts as
      upstream buildsystem was trying to build octave stuff even without
      debian/rules telling it to.
  * Add tcl8.6 and tk8.6 to build-conflicts, having multiple versions of
    tcl/tk arround seems to break the build.

 -- Axel Beckert <abe@debian.org>  Wed, 14 Oct 2015 17:17:48 +0200

=== debian/control ===
Source: plplot
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Andrew Ross <andrewross@users.sourceforge.net>
Standards-Version: 3.9.5
Build-Depends: cmake (>= 2.6.3), debhelper (>= 9), 
 tcl8.5-dev, tk8.5-dev, itcl3-dev, libx11-dev, libxext-dev,
 libxi-dev, gfortran, itk3-dev, iwidgets4,
 m4, libqhull-dev (>= 2003.1-8), 
 libxml-parser-perl, libxml-dom-perl, libltdl3-dev, pkg-config, 
 slice, python-gtk2-dev, libwxgtk3.0-dev, 
 python-all-dev (>= 2.6.6-3~),
 python-numpy (>= 1:1.4.1-4~), default-jdk,
 fastjar, swig, libqt4-dev, python-sip-dev,
 python-qt4, python-qt4-dev, 
 ocaml-nox, camlidl, ocaml-findlib, libcairo-ocaml-dev,
 liblablgtk2-ocaml-dev, liblua5.1-0-dev, lua5.1, libshp-dev,
 xvfb, xauth, dh-python
Build-Depends-Indep: xmlto, fop, docbook-xml, docbook-xsl, docbook2x, 
 dblatex, texlive-xetex, ghostscript, lmodern, fonts-freefont-ttf
Build-Conflicts: libplplot5, tcl8.6, tk8.6
X-Python-Version: >=2.4
Homepage: http://www.plplot.org
Vcs-Svn: https://plplot.svn.sourceforge.net/svnroot/plplot/trunk/debian
Vcs-Browser: http://plplot.svn.sourceforge.net/viewvc/plplot/trunk/debian/

Package: libplplot12
Architecture: any
Section: libs
Conflicts: libplplot11
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: plplot12-driver-xwin, plplot12-driver-gd,
 plplot12-driver-cairo, plplot12-driver-qt, plplot12-driver-wxwidgets, plplot-tcl
Replaces: plplot-bin (<< 5.9.6-1)
Breaks: plplot-bin (<<5.9.6-1)
Description: Scientific plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the PLplot library for C, as well as the necessary
 data files.

Package: libplplot-dev
Architecture: any
Section: libdevel
Recommends: pkg-config, cmake, libplplot-ocaml, libplplot-lua, libplplot-d
Suggests: plplot-doc
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: libplplot12 (= ${binary:Version}), libqhull-dev, libfreetype6-dev,
 libltdl3-dev, libqsastime-dev, ${misc:Depends}, 
 libplplot-c++11 (= ${binary:Version}), libplplot-fortran10 (= ${binary:Version}),
 plplot12-driver-qt (= ${binary:Version}), 
 plplot12-driver-wxwidgets (= ${binary:Version})
Breaks: libplplot-fortran9 (<< 5.9.8-1)
Description: Scientific plotting library (development files)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains all that is needed for doing development in C, C++
 and Fortran with PLplot.  Examples of programs for these languages are
 also included.  For development in Tcl/Tk, Python and Java 
 install the plplot-tcl-dev, python-plplot
 and libplplot-java packages, respectively. This package also includes the 
 OCaml and lua examples. To use one of these languages you will also 
 need to install the libplplot-xxx package for that language.

Package: libplplot-c++11
Architecture: any
Section: libs
Conflicts: libplplot5, libplplot-c++9, libplplot-c++9c2, libplplot-c++10
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scientific plotting library (C++ binding)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the C++ binding for PLplot.

Package: libplplot-fortran10
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}  , ${misc:Depends}
Description: Scientific plotting library (fortran bindings)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Fortran 95 bindings for PLplot. Note: the Fortran 
 77 bindings have been deprecated upstream for some time and have now been 
 dropped from the Debian packages. 

Package: libplplot-java
Architecture: any
Section: java
Conflicts: libplplot9-java
Replaces: libplplot9-java
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scientific plotting library (Java bindings)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Java bindings for PLplot.

Package: libcsiro0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scientific plotting library (CSIRO libraries)
 This package contains two libraries developed by Pavel Sakov, from the
 CSIRO Marine Research, used in geometry applications:
 .
  * libcsirocsa: bivariate Cubic Spline Approximation library
  * libcsironn: Natural Neighbours interpolation library
 .
 The source code for these libraries are part of the plplot source
 package.

Package: libqsastime0
Architecture: any
Section: libs
Conflicts: libplplot9
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Time format conversion library
 The qsastime library is a simple library for handling time format
 conversion. It overcomes the limitations of the POSIX time handling
 routines by allow high precision time variables over a large range
 of ranges of dates and by correctly handling leap seconds. It was
 designed with the needs of scientific data plotting in mind. This 
 package provides the runtime library.
 .
 The source code for this library is part of the plplot source
 package.

Package: libqsastime-dev
Architecture: any
Section: libdevel
Breaks: libplplot-dev (<< 5.9.8-1)
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: libqsastime0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Time format conversion library (development files)
 The qsastime library is a simple library for handling time format
 conversion. It overcomes the limitations of the POSIX time handling
 routines by allow high precision time variables over a large range
 of ranges of dates and by correctly handling leap seconds. It was
 designed with the needs of scientific data plotting in mind. This 
 package provides the necessary files to do development with 
 libqsastime.
 .
 The source code for this library is part of the plplot source
 package.

Package: plplot12-driver-xwin
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Conflicts: plplot9-driver-xwin
Replaces: plplot9-driver-xwin
Description: Scientific plotting library (X11 driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package provides the X11 driver module for PLplot.

Package: plplot12-driver-wxwidgets
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: libplplot12, ${shlibs:Depends}, ${misc:Depends}
Conflicts: plplot9-driver-wxwidgets
Replaces: plplot9-driver-wxwidgets
Description: Scientific plotting library (wxWidgets driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package provides the wxWidgets driver module for PLplot.

Package: plplot-tcl
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: plplot12-driver-xwin, iwidgets4, ${shlibs:Depends}, ${misc:Depends}
Description: Tcl/Tk support for PLplot, a plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Tcl/Tk support for PLplot: shared libraries,
 Tcl modules and the Tk driver.

Package: plplot-tcl-bin
Architecture: any
Depends: plplot-tcl, ${shlibs:Depends}, ${misc:Depends}
Description: Tcl/Tk tools for PLplot, a plotting library 
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the pltcl program for interactive use of the Tcl/Tk 
 support for PLplot. 

Package: plplot-tcl-dev
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: libplplot12 (= ${binary:Version}), plplot-tcl, ${misc:Depends}
Breaks: plplot-tcl (<= 5.2.0.cvs.20030224-1)
Description: Tcl/Tk development support for PLplot, a plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters

=== debian/rules ===
#!/usr/bin/make -f
# -*- gmake -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independant
# package.
# Modified by Rafael Laboissiere <rafael@debian.org> on 1998/06/12
# for the plplot package

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Update build-depedencies in debian/control with "debian/rules control"
# after changing one of these.
BUILD_ADA = no
BUILD_D   = no
BUILD_OCT = no

# Default slice, don't change. Will be extended as necessary based on
# the above.
SLICES=UNDEF

ifeq ($(BUILD_OCT),yes)
  # Paths for Octave
  MDIR = $(shell octave-config --print LOCALAPIFCNFILEDIR)
  OCTDIR = $(shell octave-config --print LOCALAPIOCTFILEDIR)
  octver := $(shell octave-config -v)
  SLICES := $(SLICES)+OCT
endif

ifeq ($(BUILD_D),yes)
  SLICES := $(SLICES)+D
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

version		:= $(shell perl debian/get-upstream-version.pl < cmake/modules/plplot_version.cmake)
libpkg          := libplplot12
docpkg          := plplot-doc
debbase		:= $(shell pwd)/debian
debtmp		:= $(debbase)/tmp
debusr		:= $(debtmp)/usr
deblib		:= $(debusr)/lib/$(DEB_HOST_MULTIARCH)
debshr		:= $(debusr)/share
debdoc		:= $(debshr)/doc
debinfo		:= $(debshr)/info
debex		:= $(debshr)/plplot$(version)/examples

# Note cmake ignores CPPFLAGS so add them to CFLAGS and CXXFLAGS as a work around
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS) \
	   $(shell mkoctfile -p INCFLAGS)
CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CFLAGS += -fvisibility=hidden
#Don't add -fvisibility=hidden to CXXFLAGS for now as this breaks the octave bindings.
CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
#CXXFLAGS += -fvisibility=hidden
FFLAGS = $(shell dpkg-buildflags --get FFLAGS)
FFLAGS += -fvisibility=hidden
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS += -Wl,--as-needed

export verbose_test = on

CMAKE = xvfb-run cmake

JAVA_HOME = /usr/lib/jvm/default-java

PYVERS = $(shell pyversions -vr)

OCAMLABI := $(shell ocamlc -version)
OFILES := $(filter-out debian/control,$(patsubst %.in,%,$(wildcard debian/*.in)))

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Disable Ada build on sh4 - gnat not available at the moment.

ifeq ($(BUILD_ADA),yes)
ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:sh4:))
BUILD_ADA = no
endif
endif

# Configure options

ifeq ($(BUILD_ADA),yes)
ADA_OPTIONS = -DENABLE_ada=ON
SLICES := $(SLICES)+ADA
endif

JAVA_OPTIONS = \
	-DCMAKE_Java_RUNTIME=$(JAVA_HOME)/bin/java \
	-DCMAKE_Java_COMPILER=$(JAVA_HOME)/bin/javac \
	-DCMAKE_Java_ARCHIVE=$(JAVA_HOME)/bin/jar \
	-DJAVACFLAGS="-source 1.5 -target 1.5"

CONFIGURE_OPTIONS = \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOC=OFF -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DUSE_RPATH=OFF -DPLD_psttf=OFF -DENABLE_tk=ON \
        -DTCL_TCLSH=/usr/bin/tclsh8.5 \
	$(ADA_OPTIONS) $(JAVA_OPTIONS)

ifeq ($(with_oct),yes)
  CONFIGURE_OPTIONS += -DOCTAVE_OCT_DIR=$(OCTDIR)
endif

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  CONFIGURE_OPTIONS += -DBUILD_TEST=ON
endif

BUILD_DIR = $(debbase)/build_tmp
SRC_DIR = $(shell pwd)

control:
	slice -o $(SLICES):debian/control debian/control.in

config: config-stamp
config-stamp: control
	mkdir -p $(BUILD_DIR)
	( cd $(BUILD_DIR) ; \
	PKG_CONFIG_ENV=" " FC=gfortran \
	JAVA_HOME=$(JAVA_HOME) DC=$(DC) \
        CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" FFLAGS="$(FFLAGS)" \
        LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
	$(CMAKE) $(SRC_DIR) $(CONFIGURE_OPTIONS) )
	touch config-stamp

build-arch: build-arch-stamp
build-arch-stamp: config-stamp
	dh_testdir
	( cd $(BUILD_DIR) ; $(MAKE)  )
	-( cd $(BUILD_DIR) ; unset DISPLAY ; $(MAKE) test_noninteractive )
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: config-stamp
	dh_testdir
	( cd $(BUILD_DIR) ; $(CMAKE) $(SRC_DIR) $(CONFIGURE_OPTIONS) -DBUILD_DOC=ON ; \
	cd doc ; $(MAKE)  )
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp install-arch-stamp install-indep-stamp \
              config-stamp debian/files install-python*
	rm -rf $(BUILD_DIR)
	rm -rf $(debbase)/$(libpkg)
	dh_clean

install-arch: install-arch-stamp install-python
	dh_movefiles -a --no-package=$(libpkg) --no-package=libplplot-dev \
		     --no-package=python-plplot --no-package=python-plplot-qt   \
		     --no-package=libplplot-java --no-package=libplplot-ada1 \
	             --no-package=libplplot-ocaml --no-package=libplplot-lua \
	             --no-package=libplplot-d --no-package=libplplot-ada1-dev
	dh_movefiles --package=python-plplot-qt
	dh_movefiles --package=python-plplot
	dh_movefiles --package=libplplot-java
	dh_movefiles --package=libplplot-ocaml
	dh_movefiles --package=libplplot-lua
	dh_movefiles --package=libplplot-d
ifeq ($(BUILD_ADA),yes)
	dh_movefiles --package=libplplot-ada1
	dh_movefiles --package=libplplot-ada1-dev
endif
	dh_movefiles --package=libplplot-dev
	dh_movefiles --package=$(libpkg)

install-arch-stamp: build-arch-stamp
	dh_testdir
	dh_testroot

ifeq ($(with_oct),yes)
	#Strip bindings/octave/plplot_octave.oct as this is missed by.
	# dh_strip.
	strip --strip-unneeded --remove-section=.comment $(BUILD_DIR)/bindings/octave/plplot_octave.oct
endif

	( cd $(BUILD_DIR) ; \
	  $(MAKE) DESTDIR=$(debtmp) install )

	( cd $(debdoc)/plplot ; \
	  rm -f COPYING.LIB ; \
	  mv ChangeLog.release changelog )
	mv $(debdoc)/plplot $(debdoc)/$(libpkg)

	sed -i 's,-L/usr/lib/$(DEB_HOST_MULTIARCH),,g;s,  *, ,g' \
		$(deblib)/pkgconfig/*.pc
	mkdir -p $(deblib)/$(DEB_HOST_MULTIARCH)/pkgconfig
	mafiles=$$(fgrep -l $(deblib)/pkgconfig/*.pc); \
	if [ -n "$$mafiles" ]; then \
	  mv $$mafiles $(deblib)/$(DEB_HOST_MULTIARCH)/pkgconfig/.; \
	fi

	install -d $(debex)/perl
	install --mode=644 examples/perl/x* examples/perl/README* \
		$(debex)/perl
	mv $(debex) $(debdoc)/$(libpkg)

	for i in libplplot-dev plplot-tcl plplot-tcl-bin plplot-tcl-dev	\
		plplot12-driver-xwin octave-plplot python-plplot-qt	\
		$(if $(filter yes,$(with_oct)),octave-plplot)		\
		python-plplot libplplot-c++11 plplot12-driver-wxwidgets \
		plplot12-driver-qt libplplot-java			\
		plplot12-driver-cairo libplplot-fortran10		\
		libplplot-ocaml libplplot-lua libplplot-d ; do		\
	  ln -s $(libpkg) $(debdoc)/$$i ;				\
	done
	ln -s libqsastime0 $(debdoc)/libqsastime-dev

	mv $(debshr)/java/plplot.jar $(debshr)/java/plplot-$(version).jar
	( cd $(debshr)/java ; ln -s plplot-$(version).jar plplot.jar )

ifeq ($(BUILD_ADA),yes)
	ln -s $(libpkg) $(debdoc)/libplplot-ada1
	ln -s $(libpkg) $(debdoc)/libplplot-ada1-dev
endif

	touch install-arch-stamp

install-indep: install-indep-stamp
	dh_movefiles -i

install-indep-stamp: build-indep-stamp
	( cd $(BUILD_DIR)/doc ; \
	  $(MAKE) DESTDIR=$(debtmp) install )

	mkdir -p $(debdoc)/$(docpkg)
	(cd $(debdoc)/plplot ; rm -f html/plplotdoc-html.proc ; mv html *.pdf $(debdoc)/$(docpkg))
	touch install-indep-stamp

install-python: $(PYVERS:%=install-python%)
	touch $@

install-python%: build-arch-stamp
	( cd $(BUILD_DIR) ; \
	  $(CMAKE) $(SRC_DIR) $(CONFIGURE_OPTIONS) -DPYTHON_EXECUTABLE=/usr/bin/python$* -DPYTHON_LIBRARIES=/usr/lib/python$* -DPYTHON_LIBRARY=`python-config --configdir`/libpython$*.so -DPYTHON_INCLUDE_PATH="/usr/include/python$*;/usr/include/numpy;/usr/lib/pyshared/python$*/numpy/core/include/numpy"  -DNUMERIC_INCLUDE_PATH=/usr/include/numpy ; \
	  for d in python qt_gui/pyqt4 ; do		\
	    ( cd bindings/$$d;				\
	      $(MAKE) clean ;				\
	      $(MAKE) ;					\
	      $(MAKE) DESTDIR=$(debtmp) install ) ;	\
	  done )
	touch $@

# Build architecture-independent files here.
binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_installdocs --package=$(docpkg)
